Tonyu.klass.define({
  fullName: 'user.ObjectGrid',
  shortName: 'ObjectGrid',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.TObject,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_ObjectGrid_main() {
        "use strict";
        var _this=this;
        
        "field strict";
        _this.m = new Tonyu.classes.kernel.Matrix;
        
        _this.size = _this.size||128;
        
        _this.width = _this.width||_this.size;
        
        _this.height = _this.height||_this.size;
        
        _this.symOldKey = typeof  Symbol!=="undefined"?Symbol():"oldkey"+Tonyu.globals.$Math.random();
        
      },
      fiber$main :function _trc_ObjectGrid_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        "field strict";
        _this.m = new Tonyu.classes.kernel.Matrix;
        
        _this.size = _this.size||128;
        
        _this.width = _this.width||_this.size;
        
        _this.height = _this.height||_this.size;
        
        _this.symOldKey = typeof  Symbol!=="undefined"?Symbol():"oldkey"+Tonyu.globals.$Math.random();
        
        
        _thread.retVal=_this;return;
      },
      key :function _trc_ObjectGrid_key(o) {
        "use strict";
        var _this=this;
        
        return {x: Tonyu.globals.$Math.floor(o.x/_this.width),y: Tonyu.globals.$Math.floor(o.y/_this.height)};
      },
      fiber$key :function _trc_ObjectGrid_f_key(_thread,o) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal={x: Tonyu.globals.$Math.floor(o.x/_this.width),y: Tonyu.globals.$Math.floor(o.y/_this.height)};return;
        
        
        _thread.retVal=_this;return;
      },
      add :function _trc_ObjectGrid_add(o) {
        "use strict";
        var _this=this;
        
        return _this.refresh(o);
      },
      fiber$add :function _trc_ObjectGrid_f_add(_thread,o) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_ObjectGrid_ent_add(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$refresh(_thread, o);
              __pc=1;return;
            case 1:
              _thread.exit(_thread.retVal);return;
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      refresh :function _trc_ObjectGrid_refresh(o) {
        "use strict";
        var _this=this;
        var old;
        var cur;
        
        old = o[_this.symOldKey];
        
        cur = _this.key(o);
        
        if (old&&cur&&old.x===cur.x&&old.y===cur.y) {
          return _this;
        }
        if (old) {
          _this.getOrNewGrid(old).remove(o);
          
        } else {
          o.on("die",(function anonymous_549() {
            
            _this.getOrNewGrid(o[_this.symOldKey]).remove(o);
          }));
          
        }
        _this.getOrNewGrid(cur).add(o);
        o[_this.symOldKey]=cur;
      },
      fiber$refresh :function _trc_ObjectGrid_f_refresh(_thread,o) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var old;
        var cur;
        
        old = o[_this.symOldKey];
        
        
        _thread.enter(function _trc_ObjectGrid_ent_refresh(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$key(_thread, o);
              __pc=1;return;
            case 1:
              cur=_thread.retVal;
              
              if (!(old&&cur&&old.x===cur.x&&old.y===cur.y)) { __pc=2     ; break; }
              _thread.exit(_this);return;
            case 2     :
              
              if (old) {
                _this.getOrNewGrid(old).remove(o);
                
              } else {
                o.on("die",(function anonymous_549() {
                  
                  _this.getOrNewGrid(o[_this.symOldKey]).remove(o);
                }));
                
              }
              _this.getOrNewGrid(cur).add(o);
              o[_this.symOldKey]=cur;
              _thread.exit(_this);return;
            }
          }
        });
      },
      getOrNewGrid :function _trc_ObjectGrid_getOrNewGrid(key) {
        "use strict";
        var _this=this;
        var r;
        
        r = _this.m.get(key.x,key.y);
        
        if (r) {
          return r;
        }
        r=new Tonyu.classes.user.ObjectSet;
        _this.m.set(key.x,key.y,r);
        return r;
      },
      fiber$getOrNewGrid :function _trc_ObjectGrid_f_getOrNewGrid(_thread,key) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var r;
        
        r = _this.m.get(key.x,key.y);
        
        if (r) {
          _thread.retVal=r;return;
          
        }
        r=new Tonyu.classes.user.ObjectSet;
        _this.m.set(key.x,key.y,r);
        _thread.retVal=r;return;
        
        
        _thread.retVal=_this;return;
      },
      around :function _trc_ObjectGrid_around(x,y) {
        "use strict";
        var _this=this;
        var o;
        var r;
        var cur;
        var i;
        var j;
        var g;
        var k;
        var v;
        var _it_4;
        
        o = x;
        
        if (typeof  o==="number") {
          o={x: x,y: y};
          
        }
        r = new Tonyu.classes.kernel.TQuery;
        
        cur = _this.key(o);
        
        i = - 1;
        for (; i<=1 ; i++) {
          {
            j = - 1;
            for (; j<=1 ; j++) {
              {
                g = _this.m.get(cur.x+j,cur.y+i);
                
                if (g) {
                  _it_4=Tonyu.iterator(g,2);
                  while(_it_4.next()) {
                    k=_it_4[0];
                    v=_it_4[1];
                    
                    if (v!==o) {
                      r.push(v);
                    }
                    
                  }
                  
                }
              }
            }
          }
        }
        return r;
      },
      fiber$around :function _trc_ObjectGrid_f_around(_thread,x,y) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var o;
        var r;
        var cur;
        var i;
        var j;
        var g;
        var k;
        var v;
        var _it_4;
        
        o = x;
        
        if (typeof  o==="number") {
          o={x: x,y: y};
          
        }
        r = new Tonyu.classes.kernel.TQuery;
        
        
        _thread.enter(function _trc_ObjectGrid_ent_around(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$key(_thread, o);
              __pc=1;return;
            case 1:
              cur=_thread.retVal;
              
              i = - 1;
              for (; i<=1 ; i++) {
                {
                  j = - 1;
                  for (; j<=1 ; j++) {
                    {
                      g = _this.m.get(cur.x+j,cur.y+i);
                      
                      if (g) {
                        _it_4=Tonyu.iterator(g,2);
                        while(_it_4.next()) {
                          k=_it_4[0];
                          v=_it_4[1];
                          
                          if (v!==o) {
                            r.push(v);
                          }
                          
                        }
                        
                      }
                    }
                  }
                }
              }
              _thread.exit(r);return;
              _thread.exit(_this);return;
            }
          }
        });
      },
      allCrash :function _trc_ObjectGrid_allCrash(o) {
        "use strict";
        var _this=this;
        
        return _this.around(o).find((function anonymous_1291(e) {
          
          return e.crashTo(o);
        }));
      },
      fiber$allCrash :function _trc_ObjectGrid_f_allCrash(_thread,o) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=_this.around(o).find((function anonymous_1291(e) {
          
          return e.crashTo(o);
        }));return;
        
        
        _thread.retVal=_this;return;
      },
      allCount :function _trc_ObjectGrid_allCount() {
        "use strict";
        var _this=this;
        var cnt;
        var k;
        var _it_15;
        var k2;
        var _it_16;
        
        cnt = 0;
        
        _it_15=Tonyu.iterator(_this.m.data,1);
        while(_it_15.next()) {
          k=_it_15[0];
          
          _it_16=Tonyu.iterator(_this.m.data[k],1);
          while(_it_16.next()) {
            k2=_it_16[0];
            
            cnt++;
            
          }
          
        }
        return cnt;
      },
      fiber$allCount :function _trc_ObjectGrid_f_allCount(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var cnt;
        var k;
        var _it_15;
        var k2;
        var _it_16;
        
        cnt = 0;
        
        _it_15=Tonyu.iterator(_this.m.data,1);
        while(_it_15.next()) {
          k=_it_15[0];
          
          _it_16=Tonyu.iterator(_this.m.data[k],1);
          while(_it_16.next()) {
            k2=_it_16[0];
            
            cnt++;
            
          }
          
        }
        _thread.retVal=cnt;return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"key":{"nowait":false},"add":{"nowait":false},"refresh":{"nowait":false},"getOrNewGrid":{"nowait":false},"around":{"nowait":false},"allCrash":{"nowait":false},"allCount":{"nowait":false}},"fields":{"m":{},"size":{},"width":{},"height":{},"symOldKey":{}}}
});
Tonyu.klass.define({
  fullName: 'user.ObjectSet',
  shortName: 'ObjectSet',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.TObject,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_ObjectSet_main() {
        "use strict";
        var _this=this;
        
        _this.h={};
      },
      fiber$main :function _trc_ObjectSet_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.h={};
        
        _thread.retVal=_this;return;
      },
      add :function _trc_ObjectSet_add(o) {
        "use strict";
        var _this=this;
        var id;
        
        id = _this.getID(o);
        
        _this.h[id]=o;
      },
      fiber$add :function _trc_ObjectSet_f_add(_thread,o) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var id;
        
        
        _thread.enter(function _trc_ObjectSet_ent_add(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$getID(_thread, o);
              __pc=1;return;
            case 1:
              id=_thread.retVal;
              
              _this.h[id]=o;
              _thread.exit(_this);return;
            }
          }
        });
      },
      contains :function _trc_ObjectSet_contains(o) {
        "use strict";
        var _this=this;
        var id;
        
        id = _this.getID(o);
        
        return _this.h[id];
      },
      fiber$contains :function _trc_ObjectSet_f_contains(_thread,o) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var id;
        
        
        _thread.enter(function _trc_ObjectSet_ent_contains(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$getID(_thread, o);
              __pc=1;return;
            case 1:
              id=_thread.retVal;
              
              _thread.exit(_this.h[id]);return;
              _thread.exit(_this);return;
            }
          }
        });
      },
      remove :function _trc_ObjectSet_remove(o) {
        "use strict";
        var _this=this;
        var id;
        
        id = _this.getID(o);
        
        if (! _this.h[id]) {
          return null;
        }
        delete _this.h[id];
        return o;
      },
      fiber$remove :function _trc_ObjectSet_f_remove(_thread,o) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var id;
        
        
        _thread.enter(function _trc_ObjectSet_ent_remove(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$getID(_thread, o);
              __pc=1;return;
            case 1:
              id=_thread.retVal;
              
              if (!(! _this.h[id])) { __pc=2     ; break; }
              _thread.exit(null);return;
            case 2     :
              
              delete _this.h[id];
              _thread.exit(o);return;
              _thread.exit(_this);return;
            }
          }
        });
      },
      keys :function _trc_ObjectSet_keys() {
        "use strict";
        var _this=this;
        
        return Object.keys(_this.h);
      },
      fiber$keys :function _trc_ObjectSet_f_keys(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=Object.keys(_this.h);return;
        
        
        _thread.retVal=_this;return;
      },
      tonyuIterator :function _trc_ObjectSet_tonyuIterator(arity) {
        "use strict";
        var _this=this;
        
        return Tonyu.iterator(_this.h,arity);
      },
      fiber$tonyuIterator :function _trc_ObjectSet_f_tonyuIterator(_thread,arity) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=Tonyu.iterator(_this.h,arity);return;
        
        
        _thread.retVal=_this;return;
      },
      getID :function _trc_ObjectSet_getID(o) {
        "use strict";
        var _this=this;
        
        if (o.__id) {
          return o.__id;
        }
        Tonyu.classes.user.ObjectSet.IDSEQ=Tonyu.classes.user.ObjectSet.IDSEQ||0;
        Tonyu.classes.user.ObjectSet.IDSEQ++;
        o.__id=Tonyu.classes.user.ObjectSet.IDSEQ;
        return o.__id;
      },
      fiber$getID :function _trc_ObjectSet_f_getID(_thread,o) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (o.__id) {
          _thread.retVal=o.__id;return;
          
        }
        Tonyu.classes.user.ObjectSet.IDSEQ=Tonyu.classes.user.ObjectSet.IDSEQ||0;
        Tonyu.classes.user.ObjectSet.IDSEQ++;
        o.__id=Tonyu.classes.user.ObjectSet.IDSEQ;
        _thread.retVal=o.__id;return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"add":{"nowait":false},"contains":{"nowait":false},"remove":{"nowait":false},"keys":{"nowait":false},"tonyuIterator":{"nowait":false},"getID":{"nowait":false}},"fields":{"h":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Rader',
  shortName: 'Rader',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Panel,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Rader_main() {
        "use strict";
        var _this=this;
        var _it_25;
        var _it_26;
        var _it_27;
        
        _this.alpha=200;
        _this.bgpanel=_this.drawMap();
        while (true) {
          _this.copy(_this.bgpanel,0,0);
          if (true||_this.enabled) {
            _this.ec=[];
            _it_25=Tonyu.iterator(Tonyu.globals.$mainLayer.all(Tonyu.classes.user.Car),1);
            while(_it_25.next()) {
              _this.c=_it_25[0];
              
              if (_this.c.ecar) {
                _this.ec.push(_this.c);
                
              } else {
                _this.fillStyle="lime";
                _this.fillRect(_this.floor(_this.c.x/32),_this.floor(_this.c.y/32),1,1);
                
              }
              
            }
            _it_26=Tonyu.iterator(_this.ec,1);
            while(_it_26.next()) {
              _this.c=_it_26[0];
              
              _this.fillStyle="red";
              _this.fillRect(_this.floor(_this.c.x/32)-1,_this.floor(_this.c.y/32),3,3);
              
            }
            _it_27=Tonyu.iterator(Tonyu.globals.$mainLayer.all(Tonyu.classes.user.House),1);
            while(_it_27.next()) {
              _this.c=_it_27[0];
              
              _this.fillStyle="yellow";
              if (! _this.c.ok) {
                _this.fillRect(_this.floor(_this.c.x/32)-1,_this.floor(_this.c.y/32)-1,3,3);
                
              }
              
            }
            if (Tonyu.globals.$mycar) {
              _this.fillStyle=Tonyu.globals.$frameCount%20>10?"white":"black";
              _this.fillRect(_this.floor(Tonyu.globals.$mycar.x/32)-1,_this.floor(Tonyu.globals.$mycar.y/32)-1,3,3);
              
            }
            
          } else {
            _this.fillStyle=Tonyu.globals.$frameCount%20>10?"white":"black";
            _this.fillRect(30,20,3,3);
            _this.fillText("You",100,30,20);
            _this.fillStyle="red";
            _this.fillRect(30,20+50*1,4,4);
            _this.fillText("show by\nEnemy",100,30+50*1,20);
            _this.fillStyle="yellow";
            _this.fillRect(30,20+50*2,4,4);
            _this.fillText("House to\ndeliver",100,30+50*2,20);
            
          }
          _this.updateEx(6);
          
        }
      },
      fiber$main :function _trc_Rader_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var _it_25;
        var _it_26;
        var _it_27;
        
        _this.alpha=200;
        
        _thread.enter(function _trc_Rader_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$drawMap(_thread);
              __pc=1;return;
            case 1:
              _this.bgpanel=_thread.retVal;
              
            case 2:
              _this.copy(_this.bgpanel,0,0);
              if (!(true||_this.enabled)) { __pc=3     ; break; }
              {
                _this.ec=[];
                _it_25=Tonyu.iterator(Tonyu.globals.$mainLayer.all(Tonyu.classes.user.Car),1);
                while(_it_25.next()) {
                  _this.c=_it_25[0];
                  
                  if (_this.c.ecar) {
                    _this.ec.push(_this.c);
                    
                  } else {
                    _this.fillStyle="lime";
                    _this.fillRect(_this.floor(_this.c.x/32),_this.floor(_this.c.y/32),1,1);
                    
                  }
                  
                }
                _it_26=Tonyu.iterator(_this.ec,1);
                while(_it_26.next()) {
                  _this.c=_it_26[0];
                  
                  _this.fillStyle="red";
                  _this.fillRect(_this.floor(_this.c.x/32)-1,_this.floor(_this.c.y/32),3,3);
                  
                }
                _it_27=Tonyu.iterator(Tonyu.globals.$mainLayer.all(Tonyu.classes.user.House),1);
                while(_it_27.next()) {
                  _this.c=_it_27[0];
                  
                  _this.fillStyle="yellow";
                  if (! _this.c.ok) {
                    _this.fillRect(_this.floor(_this.c.x/32)-1,_this.floor(_this.c.y/32)-1,3,3);
                    
                  }
                  
                }
                if (Tonyu.globals.$mycar) {
                  _this.fillStyle=Tonyu.globals.$frameCount%20>10?"white":"black";
                  _this.fillRect(_this.floor(Tonyu.globals.$mycar.x/32)-1,_this.floor(Tonyu.globals.$mycar.y/32)-1,3,3);
                  
                }
              }
              __pc=7     ;break;
            case 3     :
              _this.fillStyle=Tonyu.globals.$frameCount%20>10?"white":"black";
              _this.fillRect(30,20,3,3);
              _this.fiber$fillText(_thread, "You", 100, 30, 20);
              __pc=4;return;
            case 4:
              
              _this.fillStyle="red";
              _this.fillRect(30,20+50*1,4,4);
              _this.fiber$fillText(_thread, "show by\nEnemy", 100, 30+50*1, 20);
              __pc=5;return;
            case 5:
              
              _this.fillStyle="yellow";
              _this.fillRect(30,20+50*2,4,4);
              _this.fiber$fillText(_thread, "House to\ndeliver", 100, 30+50*2, 20);
              __pc=6;return;
            case 6:
              
            case 7     :
              
              _this.fiber$updateEx(_thread, 6);
              __pc=8;return;
            case 8:
              
              __pc=2;break;
            case 9     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      initialize :function _trc_Rader_initialize() {
        "use strict";
        var _this=this;
        
        __superClass.apply( _this, [{width: Tonyu.globals.$map.col,height: Tonyu.globals.$map.row,x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight-Tonyu.globals.$map.row/2,layer: Tonyu.globals.$frontLayer,scaleX: 1}]);
      },
      drawMap :function _trc_Rader_drawMap() {
        "use strict";
        var _this=this;
        var bgpanel;
        var iy;
        var ix;
        var mp;
        var mx1;
        var my1;
        
        bgpanel = new Tonyu.classes.kernel.Panel({alpha: 0,width: Tonyu.globals.$map.col,height: Tonyu.globals.$map.row});
        
        iy = 0;
        for (; iy<Tonyu.globals.$map.row ; iy++) {
          {
            ix = 0;
            for (; ix<Tonyu.globals.$map.col ; ix++) {
              {
                mp = Tonyu.globals.$map.get(ix,iy);
                
                bgpanel.fillStyle=mp==Tonyu.globals.$pat_mapchip+11?"#060":"#999";
                mx1 = ix/Tonyu.globals.$map.col*_this.width;
                
                my1 = iy/Tonyu.globals.$map.row*_this.height;
                
                bgpanel.fillRect(mx1,my1,2,2);
              }
            }
          }
        }
        return bgpanel;
      },
      fiber$drawMap :function _trc_Rader_f_drawMap(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var bgpanel;
        var iy;
        var ix;
        var mp;
        var mx1;
        var my1;
        
        bgpanel = new Tonyu.classes.kernel.Panel({alpha: 0,width: Tonyu.globals.$map.col,height: Tonyu.globals.$map.row});
        
        iy = 0;
        for (; iy<Tonyu.globals.$map.row ; iy++) {
          {
            ix = 0;
            for (; ix<Tonyu.globals.$map.col ; ix++) {
              {
                mp = Tonyu.globals.$map.get(ix,iy);
                
                bgpanel.fillStyle=mp==Tonyu.globals.$pat_mapchip+11?"#060":"#999";
                mx1 = ix/Tonyu.globals.$map.col*_this.width;
                
                my1 = iy/Tonyu.globals.$map.row*_this.height;
                
                bgpanel.fillRect(mx1,my1,2,2);
              }
            }
          }
        }
        _thread.retVal=bgpanel;return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"drawMap":{"nowait":false}},"fields":{"c":{},"bgpanel":{},"enabled":{},"ec":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Speedable',
  shortName: 'Speedable',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Speedable_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_Speedable_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      update :function _trc_Speedable_update() {
        "use strict";
        var _this=this;
        
        _this.speedC=_this.speedC||1;
        if (_this.speedC<Tonyu.globals.$speed) {
          _this.onUpdate();
          _this.speedC++;
          
        } else {
          __superClass.prototype.update.apply( _this, []);
          _this.speedC=1;
          
        }
      },
      fiber$update :function _trc_Speedable_f_update(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.speedC=_this.speedC||1;
        
        _thread.enter(function _trc_Speedable_ent_update(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              if (!(_this.speedC<Tonyu.globals.$speed)) { __pc=1     ; break; }
              {
                _this.onUpdate();
                _this.speedC++;
              }
              __pc=3     ;break;
            case 1     :
              __superClass.prototype.fiber$update.apply( _this, [_thread]);
              __pc=2;return;
            case 2:
              
              _this.speedC=1;
            case 3     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"update":{"nowait":false}},"fields":{"speedC":{}}}
});
Tonyu.klass.define({
  fullName: 'user.ACross',
  shortName: 'ACross',
  namespace: 'user',
  superclass: Tonyu.classes.user.Speedable,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_ACross_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_ACross_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      getAvails :function _trc_ACross_getAvails(car) {
        "use strict";
        var _this=this;
        
        return ["str","left","right"].filter((function anonymous_59(s) {
          
          return _this.goable(car,s);
        }));
      },
      fiber$getAvails :function _trc_ACross_f_getAvails(_thread,car) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_ACross_ent_getAvails(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _thread.exit(["str","left","right"].filter((function anonymous_59(s) {
                
                return _this.goable(car,s);
              })));return;
              _thread.exit(_this);return;
            }
          }
        });
      },
      goable :function _trc_ACross_goable(car,dir) {
        "use strict";
        var _this=this;
        var r;
        
        r = car.rotation;
        
        switch (dir) {
        case "left":
          r-=90;
          break;
          
        case "right":
          r+=90;
          break;
          
        }
        return _this.hasRoad(r);
      },
      fiber$goable :function _trc_ACross_f_goable(_thread,car,dir) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var r;
        
        r = car.rotation;
        
        switch (dir) {
        case "left":
          r-=90;
          break;
          
        case "right":
          r+=90;
          break;
          
        }
        
        _thread.enter(function _trc_ACross_ent_goable(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$hasRoad(_thread, r);
              __pc=1;return;
            case 1:
              _thread.exit(_thread.retVal);return;
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      hasRoad :function _trc_ACross_hasRoad(dir) {
        "use strict";
        var _this=this;
        var x;
        var y;
        
        x = _this.x+_this.sin(dir)*64;
        
        y = _this.y-_this.cos(dir)*64;
        
        return Tonyu.globals.$map.getAt(x,y)!==Tonyu.globals.$pat_mapchip+11;
      },
      fiber$hasRoad :function _trc_ACross_f_hasRoad(_thread,dir) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var x;
        var y;
        
        x = _this.x+_this.sin(dir)*64;
        
        y = _this.y-_this.cos(dir)*64;
        
        _thread.retVal=Tonyu.globals.$map.getAt(x,y)!==Tonyu.globals.$pat_mapchip+11;return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"getAvails":{"nowait":false},"goable":{"nowait":false},"hasRoad":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.Car',
  shortName: 'Car',
  namespace: 'user',
  superclass: Tonyu.classes.user.Speedable,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Car_main() {
        "use strict";
        var _this=this;
        
        _this.frust = 0;
        
        _this.myDefDir = 0;
        
        _this.p=_this.p||Tonyu.globals.$pat_mapchip+6;
        if (_this.mycar) {
          _this.p-=2;
        }
        if (_this.ecar) {
          _this.p-=1;
        }
        _this.spd=1;
        _this.winkl=new Tonyu.classes.kernel.Actor({layer: _this,x: - 10,y: - 10,width: 5,height: 10,fillStyle: "black"});
        _this.winkr=new Tonyu.classes.kernel.Actor({layer: _this,x: 10,y: - 10,width: 5,height: 10,fillStyle: "black"});
        _this.wcnt=0;
        if (_this.mycar) {
          _this.hp=200;
          if (Tonyu.globals.$clearCnt>=1) {
            _this.hp=9999;
          }
          
        } else {
          _this.hp=1;
        }
        while (true) {
          _this.cs=_this.cross();
          if (_this.cs) {
            _this.procCross(_this.cs);
            
          }
          _this.updateEx(5);
          
        }
      },
      fiber$main :function _trc_Car_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.frust = 0;
        
        _this.myDefDir = 0;
        
        _this.p=_this.p||Tonyu.globals.$pat_mapchip+6;
        if (_this.mycar) {
          _this.p-=2;
        }
        if (_this.ecar) {
          _this.p-=1;
        }
        _this.spd=1;
        _this.winkl=new Tonyu.classes.kernel.Actor({layer: _this,x: - 10,y: - 10,width: 5,height: 10,fillStyle: "black"});
        _this.winkr=new Tonyu.classes.kernel.Actor({layer: _this,x: 10,y: - 10,width: 5,height: 10,fillStyle: "black"});
        _this.wcnt=0;
        if (_this.mycar) {
          _this.hp=200;
          if (Tonyu.globals.$clearCnt>=1) {
            _this.hp=9999;
          }
          
        } else {
          _this.hp=1;
        }
        
        _thread.enter(function _trc_Car_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              _this.cs=_this.cross();
              if (!(_this.cs)) { __pc=3     ; break; }
              _this.fiber$procCross(_thread, _this.cs);
              __pc=2;return;
            case 2:
              
            case 3     :
              
              _this.fiber$updateEx(_thread, 5);
              __pc=4;return;
            case 4:
              
              __pc=1;break;
            case 5     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      draw :function _trc_Car_draw(ctx) {
        "use strict";
        var _this=this;
        
        if (_this.mycar) {
          _this.drawText(_this.x-20,_this.y-60,"LP:"+_this.hp,"#fff",20);
        }
        __superClass.prototype.draw.apply( _this, [ctx]);
      },
      onUpdate :function _trc_Car_onUpdate() {
        "use strict";
        var _this=this;
        var tspd;
        var d;
        var f;
        
        if (Tonyu.globals.$state==="clear"&&Tonyu.globals.$mycar===_this) {
          return _this;
        }
        _this.wcnt++;
        _this.winkl.fillStyle="black";
        _this.winkr.fillStyle="black";
        if (_this.wcnt%30>15) {
          if (_this.winkto==="left") {
            _this.winkl.fillStyle="yellow";
            
          }
          if (_this.winkto==="right") {
            _this.winkr.fillStyle="yellow";
            
          }
          
        }
        tspd = _this.spd*3;
        
        if (_this.lastHeading&&_this.lastHeading.start-->0) {
          tspd=0;
          
        } else {
          if (_this.spd>0&&_this.headingCar()) {
            tspd=0;
          }
        }
        if (tspd==0) {
          _this.frust++;
          
        } else {
          _this.frust=0;
        }
        if (_this.mycar) {
          if (_this.frust>60) {
            Tonyu.globals.$speed=3;
          } else {
            Tonyu.globals.$speed=3;
          }
          if (_this.frust>=480) {
            _this.lastHeading=null;
            _this.spd=1;
            tspd=_this.spd*3;
            
          }
          
        } else {
          if (_this.frust>=60*20) {
            _this.die();
            
          }
          
        }
        _this.position.addX(_this.dir.mulX(tspd));
        if (_this.target&&tspd>0) {
          d = _this.myAngleDiff(_this.target);
          
          _this.rotation+=d;
          
        }
        Tonyu.globals.$cars.refresh(_this);
        if (_this.mycar) {
          _this.myDefDir=Tonyu.globals.$cp.curDir;
          if (tspd==0) {
            Tonyu.globals.$cp.stopping=true;
            Tonyu.globals.$rader.enabled=255;
            
          } else {
            Tonyu.globals.$cp.stopping=false;
            Tonyu.globals.$rader.enabled=0;
            
          }
          if (Tonyu.globals.$raderFree>0) {
            Tonyu.globals.$rader.enabled=255;
            Tonyu.globals.$raderFree--;
            
          }
          f = _this.crashTo(Tonyu.classes.user.Flag);
          
          if (f&&! f.pick) {
            f.sendEvent("pick");
            Tonyu.globals.$sound.playSE(Tonyu.globals.$se_get);
            Tonyu.globals.$flagsLeft--;
            if (Tonyu.globals.$flagsLeft<=0) {
              Tonyu.globals.$state="clear";
              Tonyu.globals.$clearCnt++;
              
            }
            
          }
          
        }
        if (_this.ecar) {
          _this.eattack();
        }
      },
      __getter__dir :function _trc_Car___getter__dir() {
        "use strict";
        var _this=this;
        
        return new Tonyu.classes.kernel.Vec3(_this.sin(_this.rotation),- _this.cos(_this.rotation));
      },
      procCross :function _trc_Car_procCross(cross) {
        "use strict";
        var _this=this;
        var sig;
        var cand;
        var to;
        var tg;
        var pathmin;
        var tto;
        var _it_44;
        var pathc;
        var d;
        
        sig = cross.getSignal(_this);
        
        cand = cross.getAvails(_this);
        
        to = cand[_this.rnd(cand.length)];
        
        tg = new Tonyu.classes.kernel.Vec3({x: _this.rnd(Tonyu.globals.$map.col*32),y: _this.rnd(Tonyu.globals.$map.row*32)});
        
        if (_this.mycar) {
          Tonyu.globals.$cp.dirControllable=false;
          tg=cross.position.add(_this.sin(_this.myDefDir)*200,- _this.cos(_this.myDefDir)*200);
          
        } else {
          if (_this.ecar) {
            tg=Tonyu.globals.$mycar.position;
            
          } else {
            if (Tonyu.globals.$mycar&&Tonyu.globals.$ecar&&_this.mid) {
              tg=Tonyu.globals.$mycar.position.mul(_this.mid).add(Tonyu.globals.$ecar.position.mul(1-_this.mid));
              
            }
            
          }
        }
        pathmin = 9999999;
        
        _it_44=Tonyu.iterator(cand,1);
        while(_it_44.next()) {
          tto=_it_44[0];
          
          pathc = cross.getPoints(_this,tto);
          
          d = tg.sub(pathc[pathc.length-1]).length;
          
          if (d<pathmin) {
            _this.path=pathc;
            pathmin=d;
            to=tto;
            
          }
          
        }
        _this.winkto=to;
        while (_this.path.length) {
          _this.target=_this.path[0];
          while (_this.dist(_this.target)>5) {
            _this.update();
            
          }
          _this.target=_this.path.shift();
          if (_this.target.tag==="sig") {
            _this.spd=0;
            _this.alignRotation();
            while (sig&&! sig.goable(to)) {
              _this.update();
              
            }
            _this.spd=1;
            
          } else {
            if (_this.target.tag=="opp") {
              _this.spd=0;
              _this.alignRotation();
              while (_this.findOpponent()) {
                if (sig&&sig.state>=2) {
                  break;
                  
                }
                _this.update();
                
              }
              _this.spd=1;
              
            }
          }
          
        }
        _this.alignRotation();
        _this.target=null;
        _this.path=null;
        _this.winkto=null;
        if (_this.mycar) {
          Tonyu.globals.$cp.dirControllable=true;
          
        }
      },
      fiber$procCross :function _trc_Car_f_procCross(_thread,cross) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var sig;
        var cand;
        var to;
        var tg;
        var pathmin;
        var tto;
        var _it_44;
        var pathc;
        var d;
        
        sig = cross.getSignal(_this);
        
        cand = cross.getAvails(_this);
        
        to = cand[_this.rnd(cand.length)];
        
        tg = new Tonyu.classes.kernel.Vec3({x: _this.rnd(Tonyu.globals.$map.col*32),y: _this.rnd(Tonyu.globals.$map.row*32)});
        
        if (_this.mycar) {
          Tonyu.globals.$cp.dirControllable=false;
          tg=cross.position.add(_this.sin(_this.myDefDir)*200,- _this.cos(_this.myDefDir)*200);
          
        } else {
          if (_this.ecar) {
            tg=Tonyu.globals.$mycar.position;
            
          } else {
            if (Tonyu.globals.$mycar&&Tonyu.globals.$ecar&&_this.mid) {
              tg=Tonyu.globals.$mycar.position.mul(_this.mid).add(Tonyu.globals.$ecar.position.mul(1-_this.mid));
              
            }
            
          }
        }
        pathmin = 9999999;
        
        _it_44=Tonyu.iterator(cand,1);
        while(_it_44.next()) {
          tto=_it_44[0];
          
          pathc = cross.getPoints(_this,tto);
          
          d = tg.sub(pathc[pathc.length-1]).length;
          
          if (d<pathmin) {
            _this.path=pathc;
            pathmin=d;
            to=tto;
            
          }
          
        }
        _this.winkto=to;
        
        _thread.enter(function _trc_Car_ent_procCross(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(_this.path.length)) { __pc=17    ; break; }
              _this.target=_this.path[0];
            case 2:
              if (!(_this.dist(_this.target)>5)) { __pc=4     ; break; }
              _this.fiber$update(_thread);
              __pc=3;return;
            case 3:
              
              __pc=2;break;
            case 4     :
              
              _this.target=_this.path.shift();
              if (!(_this.target.tag==="sig")) { __pc=9     ; break; }
              _this.spd=0;
              _this.fiber$alignRotation(_thread);
              __pc=5;return;
            case 5:
              
            case 6:
              if (!(sig&&! sig.goable(to))) { __pc=8     ; break; }
              _this.fiber$update(_thread);
              __pc=7;return;
            case 7:
              
              __pc=6;break;
            case 8     :
              
              _this.spd=1;
              __pc=16    ;break;
            case 9     :
              if (!(_this.target.tag=="opp")) { __pc=15    ; break; }
              _this.spd=0;
              _this.fiber$alignRotation(_thread);
              __pc=10;return;
            case 10:
              
            case 11:
              if (!(_this.findOpponent())) { __pc=14    ; break; }
              if (!(sig&&sig.state>=2)) { __pc=12    ; break; }
              __pc=14    ; break;
              
            case 12    :
              
              _this.fiber$update(_thread);
              __pc=13;return;
            case 13:
              
              __pc=11;break;
            case 14    :
              
              _this.spd=1;
            case 15    :
              
            case 16    :
              
              __pc=1;break;
            case 17    :
              
              _this.fiber$alignRotation(_thread);
              __pc=18;return;
            case 18:
              
              _this.target=null;
              _this.path=null;
              _this.winkto=null;
              if (_this.mycar) {
                Tonyu.globals.$cp.dirControllable=true;
                
              }
              _thread.exit(_this);return;
            }
          }
        });
      },
      alignRotation :function _trc_Car_alignRotation() {
        "use strict";
        var _this=this;
        
        _this.rotation=_this.floor((_this.rotation+45)/90)*90;
      },
      fiber$alignRotation :function _trc_Car_f_alignRotation(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.rotation=_this.floor((_this.rotation+45)/90)*90;
        
        _thread.retVal=_this;return;
      },
      myAngleDiff :function _trc_Car_myAngleDiff(c) {
        "use strict";
        var _this=this;
        var r;
        
        r = _this.atan2(c.x-_this.x,_this.y-c.y);
        
        return _this.angleDiff(r,_this.rotation);
      },
      fiber$myAngleDiff :function _trc_Car_f_myAngleDiff(_thread,c) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var r;
        
        r = _this.atan2(c.x-_this.x,_this.y-c.y);
        
        _thread.retVal=_this.angleDiff(r,_this.rotation);return;
        
        
        _thread.retVal=_this;return;
      },
      arraySame :function _trc_Car_arraySame(a,b) {
        "use strict";
        var _this=this;
        var i;
        
        i = 0;
        for (; i<a.length ; i++) {
          {
            if (a[i]!==b[i]) {
              return false;
            }
          }
        }
        return true;
      },
      fiber$arraySame :function _trc_Car_f_arraySame(_thread,a,b) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var i;
        
        i = 0;
        for (; i<a.length ; i++) {
          {
            if (a[i]!==b[i]) {
              _thread.retVal=false;return;
              
            }
          }
        }
        _thread.retVal=true;return;
        
        
        _thread.retVal=_this;return;
      },
      cross :function _trc_Car_cross() {
        "use strict";
        var _this=this;
        var cs;
        
        cs = Tonyu.globals.$crosses.around(_this).find((function anonymous_5494(c) {
          
          return _this.abs(_this.myAngleDiff(c))<45;
        })).nearest(_this);
        
        if (_this.dist(cs)>160) {
          return null;
        }
        return cs;
      },
      headingCar :function _trc_Car_headingCar() {
        "use strict";
        var _this=this;
        var h;
        var rest;
        var pp;
        var _it_58;
        var dnp;
        var c;
        var _it_59;
        
        if (_this.lastHeading&&! _this.lastHeading.car.isDead()) {
          if (_this.lastHeading.car.dist(_this.lastHeading.pos)<=10) {
            return _this.lastHeading.car;
            
          }
          
        }
        _this.lastHeading=null;
        h = _this.position.clone();
        
        rest = 32;
        
        if (_this.path) {
          _it_58=Tonyu.iterator(_this.path,1);
          while(_it_58.next()) {
            pp=_it_58[0];
            
            dnp = pp.sub(h);
            
            if (dnp.length<rest) {
              h.set(pp);
              rest-=dnp.length;
              
            } else {
              h.addX(dnp.normalizeX(rest));
              rest=0;
              break;
              
              
            }
            
          }
          
        }
        if (rest>0) {
          h.addX(_this.dir.mulX(rest));
          
        }
        _it_59=Tonyu.iterator(Tonyu.globals.$cars.around(_this),1);
        while(_it_59.next()) {
          c=_it_59[0];
          
          if (c.dist(h)<=10&&! c.isDead()) {
            _this.lastHeading={car: c,pos: h,start: 60};
            return c;
            
          }
          
        }
        return null;
      },
      fiber$headingCar :function _trc_Car_f_headingCar(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var h;
        var rest;
        var pp;
        var _it_58;
        var dnp;
        var c;
        var _it_59;
        
        if (_this.lastHeading&&! _this.lastHeading.car.isDead()) {
          if (_this.lastHeading.car.dist(_this.lastHeading.pos)<=10) {
            _thread.retVal=_this.lastHeading.car;return;
            
            
          }
          
        }
        _this.lastHeading=null;
        h = _this.position.clone();
        
        rest = 32;
        
        if (_this.path) {
          _it_58=Tonyu.iterator(_this.path,1);
          while(_it_58.next()) {
            pp=_it_58[0];
            
            dnp = pp.sub(h);
            
            if (dnp.length<rest) {
              h.set(pp);
              rest-=dnp.length;
              
            } else {
              h.addX(dnp.normalizeX(rest));
              rest=0;
              break;
              
              
            }
            
          }
          
        }
        if (rest>0) {
          h.addX(_this.dir.mulX(rest));
          
        }
        _it_59=Tonyu.iterator(Tonyu.globals.$cars.around(_this),1);
        while(_it_59.next()) {
          c=_it_59[0];
          
          if (c.dist(h)<=10&&! c.isDead()) {
            _this.lastHeading={car: c,pos: h,start: 60};
            _thread.retVal=c;return;
            
            
          }
          
        }
        _thread.retVal=null;return;
        
        
        _thread.retVal=_this;return;
      },
      findOpponent :function _trc_Car_findOpponent() {
        "use strict";
        var _this=this;
        var h;
        var s;
        var d;
        var r;
        var c;
        var _it_67;
        
        h = _this.position.add(_this.dir.rotateX(90).mulX(48));
        
        s = h.add(_this.dir.mulX(- 16));
        
        d = s.add(_this.dir.mulX(256)).addX(_this.dir.rotateX(- 90).mulX(32));
        
        r = _this.rect(s,d);
        
        _it_67=Tonyu.iterator(Tonyu.globals.$cars.around(_this),1);
        while(_it_67.next()) {
          c=_it_67[0];
          
          if (r.contains(c)) {
            return c;
            
          }
          
        }
        return null;
      },
      fiber$findOpponent :function _trc_Car_f_findOpponent(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var h;
        var s;
        var d;
        var r;
        var c;
        var _it_67;
        
        h = _this.position.add(_this.dir.rotateX(90).mulX(48));
        
        s = h.add(_this.dir.mulX(- 16));
        
        d = s.add(_this.dir.mulX(256)).addX(_this.dir.rotateX(- 90).mulX(32));
        
        
        _thread.enter(function _trc_Car_ent_findOpponent(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$rect(_thread, s, d);
              __pc=1;return;
            case 1:
              r=_thread.retVal;
              
              _it_67=Tonyu.iterator(Tonyu.globals.$cars.around(_this),1);
            case 2:
              if (!(_it_67.next())) { __pc=4     ; break; }
              c=_it_67[0];
              
              if (!(r.contains(c))) { __pc=3     ; break; }
              _thread.exit(c);return;
            case 3     :
              
              __pc=2;break;
            case 4     :
              
              _thread.exit(null);return;
              _thread.exit(_this);return;
            }
          }
        });
      },
      rect :function _trc_Car_rect(s,d) {
        "use strict";
        var _this=this;
        var xmin;
        var xmax;
        var ymin;
        var ymax;
        var x;
        var y;
        var width;
        var height;
        
        xmin = _this.min(s.x,d.x);
        
        xmax = _this.max(s.x,d.x);
        
        ymin = _this.min(s.y,d.y);
        
        ymax = _this.max(s.y,d.y);
        
        x = (s.x+d.x)/2;
        
        y = (s.y+d.y)/2;
        
        width = xmax-xmin;
        
        height = ymax-ymin;
        
        return new Tonyu.classes.kernel.RectShape({x: x,y: y,width: width,height: height});
      },
      fiber$rect :function _trc_Car_f_rect(_thread,s,d) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var xmin;
        var xmax;
        var ymin;
        var ymax;
        var x;
        var y;
        var width;
        var height;
        
        xmin = _this.min(s.x,d.x);
        
        xmax = _this.max(s.x,d.x);
        
        ymin = _this.min(s.y,d.y);
        
        ymax = _this.max(s.y,d.y);
        
        x = (s.x+d.x)/2;
        
        y = (s.y+d.y)/2;
        
        width = xmax-xmin;
        
        height = ymax-ymin;
        
        _thread.retVal=new Tonyu.classes.kernel.RectShape({x: x,y: y,width: width,height: height});return;
        
        
        _thread.retVal=_this;return;
      },
      eattack :function _trc_Car_eattack() {
        "use strict";
        var _this=this;
        var i;
        var pp;
        var c;
        var _it_82;
        
        if (_this.dist(Tonyu.globals.$mycar)>80) {
          return _this;
        }
        i = 0.2;
        for (; i<1 ; i+=0.2) {
          {
            pp = Tonyu.globals.$mycar.position.mul(i).add(_this.position.mul(1-i));
            
            _it_82=Tonyu.iterator(Tonyu.globals.$cars.around(_this),1);
            while(_it_82.next()) {
              c=_it_82[0];
              
              if (c!==Tonyu.globals.$mycar&&c!==_this&&c.dist(pp)<20) {
                return _this;
                
              }
              
            }
          }
        }
        new Tonyu.classes.user.EAttack({x: _this.x,y: _this.y,rotation: _this.rotation,p: _this.p});
        _this.die();
      },
      fiber$eattack :function _trc_Car_f_eattack(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var i;
        var pp;
        var c;
        var _it_82;
        
        if (_this.dist(Tonyu.globals.$mycar)>80) {
          _thread.retVal=_this;return;
          
        }
        i = 0.2;
        for (; i<1 ; i+=0.2) {
          {
            pp = Tonyu.globals.$mycar.position.mul(i).add(_this.position.mul(1-i));
            
            _it_82=Tonyu.iterator(Tonyu.globals.$cars.around(_this),1);
            while(_it_82.next()) {
              c=_it_82[0];
              
              if (c!==Tonyu.globals.$mycar&&c!==_this&&c.dist(pp)<20) {
                _thread.retVal=_this;return;
                
                
              }
              
            }
          }
        }
        new Tonyu.classes.user.EAttack({x: _this.x,y: _this.y,rotation: _this.rotation,p: _this.p});
        _this.die();
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"draw":{"nowait":true},"onUpdate":{"nowait":true},"__getter__dir":{"nowait":true},"procCross":{"nowait":false},"alignRotation":{"nowait":false},"myAngleDiff":{"nowait":false},"arraySame":{"nowait":false},"cross":{"nowait":true},"headingCar":{"nowait":false},"findOpponent":{"nowait":false},"rect":{"nowait":false},"eattack":{"nowait":false}},"fields":{"lastHeading":{},"frust":{},"myDefDir":{},"mycar":{},"ecar":{},"spd":{},"winkl":{},"winkr":{},"wcnt":{},"hp":{},"cs":{},"winkto":{},"mid":{},"path":{}}}
});
Tonyu.klass.define({
  fullName: 'user.CarGen',
  shortName: 'CarGen',
  namespace: 'user',
  superclass: Tonyu.classes.user.Speedable,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_CarGen_main() {
        "use strict";
        var _this=this;
        
        _this.alpha=0;
        _this.flags=Tonyu.globals.$flags;
        _this.mid=0;
        while (true) {
          _this.i=0;for (; _this.i<2 ; _this.i++) {
            {
              _this.x=_this.rnd(Tonyu.globals.$map.col)*32+16;
              _this.y=_this.rnd(Tonyu.globals.$map.row)*32+16;
              if (_this.doGen()) {
                break;
                
              }
            }
          }
          _this.update();
          
        }
      },
      fiber$main :function _trc_CarGen_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.alpha=0;
        _this.flags=Tonyu.globals.$flags;
        _this.mid=0;
        
        _thread.enter(function _trc_CarGen_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              _this.i=0;for (; _this.i<2 ; _this.i++) {
                {
                  _this.x=_this.rnd(Tonyu.globals.$map.col)*32+16;
                  _this.y=_this.rnd(Tonyu.globals.$map.row)*32+16;
                  if (_this.doGen()) {
                    break;
                    
                  }
                }
              }
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      doGen :function _trc_CarGen_doGen() {
        "use strict";
        var _this=this;
        var pp;
        var c;
        
        if (! _this.screenOut()) {
          return null;
        }
        pp = Tonyu.globals.$map.getAt(_this.x,_this.y);
        
        c = _this.all(Tonyu.classes.user.ACross).nearest();
        
        if (c&&_this.dist(c)<200) {
          return null;
        }
        if (_this.all(Tonyu.classes.user.Car).length>60) {
          return null;
        }
        if (_this.within(Tonyu.classes.user.Car,64)) {
          return null;
        }
        if (pp===Tonyu.globals.$pat_mapchip+0||pp===Tonyu.globals.$pat_mapchip+33) {
          if (_this.flags>0) {
            new Tonyu.classes.user.Flag({x: _this.x+32*(_this.rnd(2)*2-1),y: _this.y});
            _this.flags--;
            
          }
          _this.mid=! _this.mid;
          return new Tonyu.classes.user.Car({x: _this.x-32,y: _this.y,p: Tonyu.globals.$pat_mapchip+6,mid: _this.mid,ecar: true});
          
        } else {
          if (pp===Tonyu.globals.$pat_mapchip+3||pp===Tonyu.globals.$pat_mapchip+30) {
            if (_this.flags>0) {
              new Tonyu.classes.user.Flag({x: _this.x,y: _this.y+32*(_this.rnd(2)*2-1)});
              _this.flags--;
              
            }
            _this.mid=_this.floor(_this.mid+0.1);
            return new Tonyu.classes.user.Car({x: _this.x,y: _this.y-32,p: Tonyu.globals.$pat_mapchip+6,rotation: 90,mid: _this.mid,ecar: true});
            
          }
        }
      },
      fiber$doGen :function _trc_CarGen_f_doGen(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var pp;
        var c;
        
        if (! _this.screenOut()) {
          _thread.retVal=null;return;
          
        }
        pp = Tonyu.globals.$map.getAt(_this.x,_this.y);
        
        c = _this.all(Tonyu.classes.user.ACross).nearest();
        
        if (c&&_this.dist(c)<200) {
          _thread.retVal=null;return;
          
        }
        if (_this.all(Tonyu.classes.user.Car).length>60) {
          _thread.retVal=null;return;
          
        }
        if (_this.within(Tonyu.classes.user.Car,64)) {
          _thread.retVal=null;return;
          
        }
        if (pp===Tonyu.globals.$pat_mapchip+0||pp===Tonyu.globals.$pat_mapchip+33) {
          if (_this.flags>0) {
            new Tonyu.classes.user.Flag({x: _this.x+32*(_this.rnd(2)*2-1),y: _this.y});
            _this.flags--;
            
          }
          _this.mid=! _this.mid;
          _thread.retVal=new Tonyu.classes.user.Car({x: _this.x-32,y: _this.y,p: Tonyu.globals.$pat_mapchip+6,mid: _this.mid,ecar: true});return;
          
          
        } else {
          if (pp===Tonyu.globals.$pat_mapchip+3||pp===Tonyu.globals.$pat_mapchip+30) {
            if (_this.flags>0) {
              new Tonyu.classes.user.Flag({x: _this.x,y: _this.y+32*(_this.rnd(2)*2-1)});
              _this.flags--;
              
            }
            _this.mid=_this.floor(_this.mid+0.1);
            _thread.retVal=new Tonyu.classes.user.Car({x: _this.x,y: _this.y-32,p: Tonyu.globals.$pat_mapchip+6,rotation: 90,mid: _this.mid,ecar: true});return;
            
            
          }
        }
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"doGen":{"nowait":false}},"fields":{"flags":{},"mid":{},"i":{}}}
});
Tonyu.klass.define({
  fullName: 'user.CP',
  shortName: 'CP',
  namespace: 'user',
  superclass: Tonyu.classes.user.Speedable,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_CP_main() {
        "use strict";
        var _this=this;
        
        _this.h=Tonyu.globals.$screenHeight;
        _this.w=Tonyu.globals.$screenWidth;
        _this.disabledEffect={alpha: 128};
        _this.up=new Tonyu.classes.kernel.Button({top: _this.h-150,left: 50,width: 50,key: "up",text: "↑",value: 0,onClick: Tonyu.bindFunc(_this,_this.onClick),disabledEffect: _this.disabledEffect});
        _this.left=new Tonyu.classes.kernel.Button({top: _this.h-100,left: 0,width: 50,key: "left",text: "←",value: 270,onClick: Tonyu.bindFunc(_this,_this.onClick),disabledEffect: _this.disabledEffect});
        _this.down=new Tonyu.classes.kernel.Button({top: _this.h-50,left: 50,width: 50,key: "down",text: "↓",value: 180,onClick: Tonyu.bindFunc(_this,_this.onClick),disabledEffect: _this.disabledEffect});
        _this.right=new Tonyu.classes.kernel.Button({top: _this.h-100,left: 100,width: 50,key: "right",text: "→",value: 90,onClick: Tonyu.bindFunc(_this,_this.onClick),disabledEffect: _this.disabledEffect});
        _this.dirs=[_this.up,_this.left,_this.down,_this.right];
        _this.up.fillStyle="#f88";
        _this.dirControllable=true;
        _this.up.selected=true;
      },
      fiber$main :function _trc_CP_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.h=Tonyu.globals.$screenHeight;
        _this.w=Tonyu.globals.$screenWidth;
        _this.disabledEffect={alpha: 128};
        _this.up=new Tonyu.classes.kernel.Button({top: _this.h-150,left: 50,width: 50,key: "up",text: "↑",value: 0,onClick: Tonyu.bindFunc(_this,_this.onClick),disabledEffect: _this.disabledEffect});
        _this.left=new Tonyu.classes.kernel.Button({top: _this.h-100,left: 0,width: 50,key: "left",text: "←",value: 270,onClick: Tonyu.bindFunc(_this,_this.onClick),disabledEffect: _this.disabledEffect});
        _this.down=new Tonyu.classes.kernel.Button({top: _this.h-50,left: 50,width: 50,key: "down",text: "↓",value: 180,onClick: Tonyu.bindFunc(_this,_this.onClick),disabledEffect: _this.disabledEffect});
        _this.right=new Tonyu.classes.kernel.Button({top: _this.h-100,left: 100,width: 50,key: "right",text: "→",value: 90,onClick: Tonyu.bindFunc(_this,_this.onClick),disabledEffect: _this.disabledEffect});
        _this.dirs=[_this.up,_this.left,_this.down,_this.right];
        _this.up.fillStyle="#f88";
        _this.dirControllable=true;
        _this.up.selected=true;
        
        _thread.retVal=_this;return;
      },
      __setter__stopping :function _trc_CP___setter__stopping(value) {
        "use strict";
        var _this=this;
        
        if (! value) {
          Tonyu.globals.$speed=2;
          Tonyu.globals.$rader.enabled=0;
          
        }
      },
      __getter__curDir :function _trc_CP___getter__curDir() {
        "use strict";
        var _this=this;
        var d;
        var _it_89;
        
        _it_89=Tonyu.iterator(_this.dirs,1);
        while(_it_89.next()) {
          d=_it_89[0];
          
          if (d.selected) {
            return d.value;
          }
          
        }
        return 0;
      },
      onClick :function _trc_CP_onClick(b) {
        "use strict";
        var _this=this;
        var d;
        var _it_92;
        
        if (_this.dirs.indexOf(b)>=0) {
          _it_92=Tonyu.iterator(_this.dirs,1);
          while(_it_92.next()) {
            d=_it_92[0];
            
            if (d===b) {
              b.fillStyle="#fa8";
              if (! b.selected) {
                if (! _this.dirControllable) {
                  Tonyu.globals.$dirWarn.alpha=255;
                  
                }
                
              }
              b.selected=true;
              
            } else {
              d.fillStyle="#888";
              d.selected=false;
              
            }
            
          }
          
        }
        if (b===_this.x2) {
          Tonyu.globals.$speed=3-Tonyu.globals.$speed;
          
        }
      },
      fiber$onClick :function _trc_CP_f_onClick(_thread,b) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var d;
        var _it_92;
        
        if (_this.dirs.indexOf(b)>=0) {
          _it_92=Tonyu.iterator(_this.dirs,1);
          while(_it_92.next()) {
            d=_it_92[0];
            
            if (d===b) {
              b.fillStyle="#fa8";
              if (! b.selected) {
                if (! _this.dirControllable) {
                  Tonyu.globals.$dirWarn.alpha=255;
                  
                }
                
              }
              b.selected=true;
              
            } else {
              d.fillStyle="#888";
              d.selected=false;
              
            }
            
          }
          
        }
        if (b===_this.x2) {
          Tonyu.globals.$speed=3-Tonyu.globals.$speed;
          
        }
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"__setter__stopping":{"nowait":true},"__getter__curDir":{"nowait":true},"onClick":{"nowait":false}},"fields":{"h":{},"w":{},"disabledEffect":{},"up":{},"left":{},"down":{},"right":{},"dirs":{},"dirControllable":{},"x2":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Cross',
  shortName: 'Cross',
  namespace: 'user',
  superclass: Tonyu.classes.user.ACross,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Cross_main() {
        "use strict";
        var _this=this;
        
        _this.hr = 0;
        
        _this.i = 0;
        for (; _this.i<360 ; _this.i+=90) {
          {
            if (_this.hasRoad(_this.i)) {
              _this.hr++;
            }
          }
        }
        if (_this.hr<=2) {
          Tonyu.globals.$crosses.refresh(new Tonyu.classes.user.Gamma({x: _this.x,y: _this.y}));
          _this.die();
          _this.update();
          
        }
        _this.alpha=0;
        _this.signals=[];
        _this.signals[0]=new Tonyu.classes.user.Signal({layer: _this,x: - 32,y: - 64});
        _this.signals[90]=new Tonyu.classes.user.Signal({layer: _this,x: 64,y: - 32,rotation: 90});
        _this.signals[180]=new Tonyu.classes.user.Signal({layer: _this,x: 32,y: 64,rotation: 180});
        _this.signals[270]=new Tonyu.classes.user.Signal({layer: _this,x: - 64,y: 32,rotation: 270});
        while (true) {
          _this.i=0;for (; _this.i<=90 ; _this.i+=90) {
            {
              _this.updateEx(40);
              _this.setSig(_this.i,0);
              _this.skip=false;
              _this.updateEx(30);
              _this.j=_this.rnd(30);for (; _this.j<60 ; _this.j++) {
                {
                  if (_this.waiting(_this.i)==0&&_this.waiting(90-_this.i)!==0) {
                    _this.skip=true;
                    break;
                    
                    
                  }
                  _this.update();
                }
              }
              if (! _this.skip) {
                _this.setSig(_this.i,1);
                _this.updateEx(40);
                _this.setSig(_this.i,2);
                _this.updateEx(40);
                
              }
              _this.setSig(_this.i,3);
              _this.updateEx(40);
              _this.setSig(_this.i,4);
            }
          }
          
        }
      },
      fiber$main :function _trc_Cross_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.hr = 0;
        
        _this.i = 0;
        for (; _this.i<360 ; _this.i+=90) {
          {
            if (_this.hasRoad(_this.i)) {
              _this.hr++;
            }
          }
        }
        
        _thread.enter(function _trc_Cross_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              if (!(_this.hr<=2)) { __pc=2     ; break; }
              Tonyu.globals.$crosses.refresh(new Tonyu.classes.user.Gamma({x: _this.x,y: _this.y}));
              _this.die();
              _this.fiber$update(_thread);
              __pc=1;return;
            case 1:
              
            case 2     :
              
              _this.alpha=0;
              _this.signals=[];
              _this.signals[0]=new Tonyu.classes.user.Signal({layer: _this,x: - 32,y: - 64});
              _this.signals[90]=new Tonyu.classes.user.Signal({layer: _this,x: 64,y: - 32,rotation: 90});
              _this.signals[180]=new Tonyu.classes.user.Signal({layer: _this,x: 32,y: 64,rotation: 180});
              _this.signals[270]=new Tonyu.classes.user.Signal({layer: _this,x: - 64,y: 32,rotation: 270});
            case 3:
              _this.i=0;
            case 4:
              if (!(_this.i<=90)) { __pc=22    ; break; }
              _this.fiber$updateEx(_thread, 40);
              __pc=5;return;
            case 5:
              
              _this.fiber$setSig(_thread, _this.i, 0);
              __pc=6;return;
            case 6:
              
              _this.skip=false;
              _this.fiber$updateEx(_thread, 30);
              __pc=7;return;
            case 7:
              
              _this.j=_this.rnd(30);
            case 8:
              if (!(_this.j<60)) { __pc=12    ; break; }
              if (!(_this.waiting(_this.i)==0&&_this.waiting(90-_this.i)!==0)) { __pc=9     ; break; }
              _this.skip=true;
              __pc=12    ; break;
              
            case 9     :
              
              _this.fiber$update(_thread);
              __pc=10;return;
            case 10:
              
            case 11    :
              _this.j++;
              __pc=8;break;
            case 12    :
              
              if (!(! _this.skip)) { __pc=17    ; break; }
              _this.fiber$setSig(_thread, _this.i, 1);
              __pc=13;return;
            case 13:
              
              _this.fiber$updateEx(_thread, 40);
              __pc=14;return;
            case 14:
              
              _this.fiber$setSig(_thread, _this.i, 2);
              __pc=15;return;
            case 15:
              
              _this.fiber$updateEx(_thread, 40);
              __pc=16;return;
            case 16:
              
            case 17    :
              
              _this.fiber$setSig(_thread, _this.i, 3);
              __pc=18;return;
            case 18:
              
              _this.fiber$updateEx(_thread, 40);
              __pc=19;return;
            case 19:
              
              _this.fiber$setSig(_thread, _this.i, 4);
              __pc=20;return;
            case 20:
              
            case 21    :
              _this.i+=90;
              __pc=4;break;
            case 22    :
              
              __pc=3;break;
            case 23    :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      waiting :function _trc_Cross_waiting(i) {
        "use strict";
        var _this=this;
        var cnt;
        var c;
        var _it_95;
        
        cnt = 0;
        
        if (i==0) {
          _this.r=new Tonyu.classes.kernel.RectShape({x: _this.x,y: _this.y,width: 96,height: 300});
          
        } else {
          _this.r=new Tonyu.classes.kernel.RectShape({x: _this.x,y: _this.y,width: 300,height: 96});
          
        }
        _it_95=Tonyu.iterator(Tonyu.globals.$cars.around(_this.x,_this.y),1);
        while(_it_95.next()) {
          c=_it_95[0];
          
          if (_this.r.contains(c)) {
            cnt++;
            
          }
          
        }
        return cnt;
      },
      fiber$waiting :function _trc_Cross_f_waiting(_thread,i) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var cnt;
        var c;
        var _it_95;
        
        cnt = 0;
        
        if (i==0) {
          _this.r=new Tonyu.classes.kernel.RectShape({x: _this.x,y: _this.y,width: 96,height: 300});
          
        } else {
          _this.r=new Tonyu.classes.kernel.RectShape({x: _this.x,y: _this.y,width: 300,height: 96});
          
        }
        _it_95=Tonyu.iterator(Tonyu.globals.$cars.around(_this.x,_this.y),1);
        while(_it_95.next()) {
          c=_it_95[0];
          
          if (_this.r.contains(c)) {
            cnt++;
            
          }
          
        }
        _thread.retVal=cnt;return;
        
        
        _thread.retVal=_this;return;
      },
      setSig :function _trc_Cross_setSig(r,s) {
        "use strict";
        var _this=this;
        
        _this.signals[r].state=s;
        _this.signals[180+r].state=s;
      },
      fiber$setSig :function _trc_Cross_f_setSig(_thread,r,s) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.signals[r].state=s;
        _this.signals[180+r].state=s;
        
        _thread.retVal=_this;return;
      },
      getSignal :function _trc_Cross_getSignal(car) {
        "use strict";
        var _this=this;
        var r;
        
        r = car.rotation;
        
        r=_this.floor((r+45)/90)*90;
        r=_this.amod(r,360);
        return _this.signals[r];
      },
      fiber$getSignal :function _trc_Cross_f_getSignal(_thread,car) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var r;
        
        r = car.rotation;
        
        r=_this.floor((r+45)/90)*90;
        r=_this.amod(r,360);
        _thread.retVal=_this.signals[r];return;
        
        
        _thread.retVal=_this;return;
      },
      getPoints :function _trc_Cross_getPoints(car,dir) {
        "use strict";
        var _this=this;
        var r;
        var ds;
        
        r = car.rotation;
        
        
        switch (dir) {
        case "str":
          ds=[{x: - 32,y: 96,tag: "sig"},{x: - 32,y: - 64}];
          break;
          
        case "left":
          ds=[{x: - 32,y: 96,tag: "sig"},{x: - 32,y: 64},{x: - 64,y: 32},{x: - 96,y: 32}];
          break;
          
        case "right":
          ds=[{x: 0,y: 128},{x: 0,y: 96,tag: "sig"},{x: 0,y: 32,tag: "opp"},{x: 64,y: - 32},{x: 96,y: - 32}];
          break;
          
        }
        return ds.map((function anonymous_2032(d) {
          var e;
          
          e = _this.position.add(new Tonyu.classes.kernel.Vec3(d).rotateX(r));
          
          e.tag=d.tag;
          return e;
        }));
      },
      fiber$getPoints :function _trc_Cross_f_getPoints(_thread,car,dir) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var r;
        var ds;
        
        r = car.rotation;
        
        
        switch (dir) {
        case "str":
          ds=[{x: - 32,y: 96,tag: "sig"},{x: - 32,y: - 64}];
          break;
          
        case "left":
          ds=[{x: - 32,y: 96,tag: "sig"},{x: - 32,y: 64},{x: - 64,y: 32},{x: - 96,y: 32}];
          break;
          
        case "right":
          ds=[{x: 0,y: 128},{x: 0,y: 96,tag: "sig"},{x: 0,y: 32,tag: "opp"},{x: 64,y: - 32},{x: 96,y: - 32}];
          break;
          
        }
        _thread.retVal=ds.map((function anonymous_2032(d) {
          var e;
          
          e = _this.position.add(new Tonyu.classes.kernel.Vec3(d).rotateX(r));
          
          e.tag=d.tag;
          return e;
        }));return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"waiting":{"nowait":false},"setSig":{"nowait":false},"getSignal":{"nowait":false},"getPoints":{"nowait":false}},"fields":{"hr":{},"i":{},"signals":{},"skip":{},"j":{},"r":{}}}
});
Tonyu.klass.define({
  fullName: 'user.EAttack',
  shortName: 'EAttack',
  namespace: 'user',
  superclass: Tonyu.classes.user.Speedable,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_EAttack_main() {
        "use strict";
        var _this=this;
        
        _this.ep = _this.position.clone();
        
        _this.i = 0.1;
        for (; _this.i<=1 ; _this.i+=0.1) {
          {
            _this.pp = Tonyu.globals.$mycar.position.mul(_this.i).add(_this.ep.mul(1-_this.i));
            
            _this.position.set(_this.pp);
            _this.update();
          }
        }
        _this.rotation=0;
        _this.scaleX=2;
        Tonyu.globals.$mycar.hp--;
        _this.hp = Tonyu.globals.$mycar.hp<=0;
        
        if (_this.hp) {
          Tonyu.globals.$mycar.die();
        }
        Tonyu.globals.$speed=2;
        _this.p=Tonyu.globals.$pat_mapchip+34;
        if (_this.hp) {
          Tonyu.globals.$sound.stopBGM();
        }
        Tonyu.globals.$sound.pauseBGM();
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_bang);
        _this.updateEx(90);
        Tonyu.globals.$sound.resumeBGM();
        _this.updateEx(30);
        if (_this.hp) {
          Tonyu.globals.$state="gameover";
        }
        Tonyu.globals.$map.setOnAt(_this.x,_this.y,Tonyu.globals.$pat_mapchip+34);
        _this.die();
      },
      fiber$main :function _trc_EAttack_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.ep = _this.position.clone();
        
        
        _thread.enter(function _trc_EAttack_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.i = 0.1;
              
            case 1:
              if (!(_this.i<=1)) { __pc=4     ; break; }
              _this.pp = Tonyu.globals.$mycar.position.mul(_this.i).add(_this.ep.mul(1-_this.i));
              
              _this.position.set(_this.pp);
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
            case 3     :
              _this.i+=0.1;
              __pc=1;break;
            case 4     :
              
              _this.rotation=0;
              _this.scaleX=2;
              Tonyu.globals.$mycar.hp--;
              _this.hp = Tonyu.globals.$mycar.hp<=0;
              
              if (_this.hp) {
                Tonyu.globals.$mycar.die();
              }
              Tonyu.globals.$speed=2;
              _this.p=Tonyu.globals.$pat_mapchip+34;
              if (_this.hp) {
                Tonyu.globals.$sound.stopBGM();
              }
              Tonyu.globals.$sound.pauseBGM();
              Tonyu.globals.$sound.playSE(Tonyu.globals.$se_bang);
              _this.fiber$updateEx(_thread, 90);
              __pc=5;return;
            case 5:
              
              Tonyu.globals.$sound.resumeBGM();
              _this.fiber$updateEx(_thread, 30);
              __pc=6;return;
            case 6:
              
              if (_this.hp) {
                Tonyu.globals.$state="gameover";
              }
              Tonyu.globals.$map.setOnAt(_this.x,_this.y,Tonyu.globals.$pat_mapchip+34);
              _this.die();
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{"ep":{},"i":{},"pp":{},"hp":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Flag',
  shortName: 'Flag',
  namespace: 'user',
  superclass: Tonyu.classes.user.Speedable,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Flag_main() {
        "use strict";
        var _this=this;
        
        _this.p=Tonyu.globals.$pat_paper;
        _this.alpha=0;
        _this.i=0;for (; _this.i<360 ; _this.i+=90) {
          {
            _this.dir=new Tonyu.classes.kernel.Vec3(_this.sin(_this.i),- _this.cos(_this.i));
            _this.road=_this.position.add(_this.dir.mul(32));
            _this.house=_this.position.add(_this.dir.mul(64));
            if (Tonyu.globals.$map.getAt(_this.road.x,_this.road.y)===Tonyu.globals.$pat_mapchip+11) {
              break;
              
              
            }
          }
        }
        new Tonyu.classes.kernel.Actor({x: _this.road.x,y: _this.road.y,p: Tonyu.globals.$pat_mapchip+12});
        _this.h=new Tonyu.classes.user.House({x: _this.house.x,y: _this.house.y,p: Tonyu.globals.$pat_house,rotation: _this.i});
        _this.waitEvent("pick");
        _this.h.ok=true;
        _this.pick=true;
        _this.zOrder=- 100;
        _this.alpha=255;
        _this.i=0;for (; _this.i<8 ; _this.i++) {
          {
            _this.position.addX(_this.dir.mul(4));
            _this.update();
          }
        }
      },
      fiber$main :function _trc_Flag_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.p=Tonyu.globals.$pat_paper;
        _this.alpha=0;
        _this.i=0;for (; _this.i<360 ; _this.i+=90) {
          {
            _this.dir=new Tonyu.classes.kernel.Vec3(_this.sin(_this.i),- _this.cos(_this.i));
            _this.road=_this.position.add(_this.dir.mul(32));
            _this.house=_this.position.add(_this.dir.mul(64));
            if (Tonyu.globals.$map.getAt(_this.road.x,_this.road.y)===Tonyu.globals.$pat_mapchip+11) {
              break;
              
              
            }
          }
        }
        new Tonyu.classes.kernel.Actor({x: _this.road.x,y: _this.road.y,p: Tonyu.globals.$pat_mapchip+12});
        _this.h=new Tonyu.classes.user.House({x: _this.house.x,y: _this.house.y,p: Tonyu.globals.$pat_house,rotation: _this.i});
        
        _thread.enter(function _trc_Flag_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$waitEvent(_thread, "pick");
              __pc=1;return;
            case 1:
              
              _this.h.ok=true;
              _this.pick=true;
              _this.zOrder=- 100;
              _this.alpha=255;
              _this.i=0;
            case 2:
              if (!(_this.i<8)) { __pc=5     ; break; }
              _this.position.addX(_this.dir.mul(4));
              _this.fiber$update(_thread);
              __pc=3;return;
            case 3:
              
            case 4     :
              _this.i++;
              __pc=2;break;
            case 5     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{"i":{},"dir":{},"road":{},"house":{},"h":{},"pick":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Gamma',
  shortName: 'Gamma',
  namespace: 'user',
  superclass: Tonyu.classes.user.ACross,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Gamma_main() {
        "use strict";
        var _this=this;
        
        _this.alpha=128;
        _this.p+=3;
      },
      fiber$main :function _trc_Gamma_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.alpha=128;
        _this.p+=3;
        
        _thread.retVal=_this;return;
      },
      getSignal :function _trc_Gamma_getSignal(car) {
        "use strict";
        var _this=this;
        
        return null;
      },
      fiber$getSignal :function _trc_Gamma_f_getSignal(_thread,car) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=null;return;
        
        
        _thread.retVal=_this;return;
      },
      getPoints :function _trc_Gamma_getPoints(car,dir) {
        "use strict";
        var _this=this;
        var r;
        var ds;
        
        r = car.rotation;
        
        
        switch (dir) {
        case "left":
          ds=[{x: - 24,y: 64},{x: - 64,y: 32}];
          break;
          
        case "right":
          ds=[{x: - 32,y: 0},{x: 64,y: - 32},{x: 96,y: - 32}];
          break;
          
        default:
          _this.print(dir,_this.x,_this.y);
          throw new Error("Cannot go str");
          
        }
        return ds.map((function anonymous_542(d) {
          var e;
          
          e = _this.position.add(new Tonyu.classes.kernel.Vec3(d).rotateX(r));
          
          e.tag=d.tag;
          return e;
        }));
      },
      fiber$getPoints :function _trc_Gamma_f_getPoints(_thread,car,dir) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var r;
        var ds;
        
        r = car.rotation;
        
        
        switch (dir) {
        case "left":
          ds=[{x: - 24,y: 64},{x: - 64,y: 32}];
          break;
          
        case "right":
          ds=[{x: - 32,y: 0},{x: 64,y: - 32},{x: 96,y: - 32}];
          break;
          
        default:
          _this.print(dir,_this.x,_this.y);
          throw new Error("Cannot go str");
          
        }
        _thread.retVal=ds.map((function anonymous_542(d) {
          var e;
          
          e = _this.position.add(new Tonyu.classes.kernel.Vec3(d).rotateX(r));
          
          e.tag=d.tag;
          return e;
        }));return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"getSignal":{"nowait":false},"getPoints":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.GridTest',
  shortName: 'GridTest',
  namespace: 'user',
  superclass: Tonyu.classes.user.Speedable,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_GridTest_main() {
        "use strict";
        var _this=this;
        var _it_108;
        
        _this.size=50;
        _this.x=_this.y=100;
        _this.zOrder=- 10;
        _this.p=Tonyu.globals.$pat_neko;
        _this.g=new Tonyu.classes.user.ObjectGrid({size: 50});
        _this.s=new Tonyu.classes.user.ObjectSet;
        _this.i=0;for (; _this.i<100 ; _this.i++) {
          {
            _this.a = new Tonyu.classes.kernel.Actor({x: _this.rnd(400),y: _this.rnd(400)});
            
            _this.g.refresh(_this.a);
            _this.s.add(_this.a);
            _this.update();
          }
        }
        while (true) {
          _this.x=Tonyu.globals.$mouseX;
          _this.y=Tonyu.globals.$mouseY;
          _it_108=Tonyu.iterator(_this.g.around(_this.x,_this.y),1);
          while(_it_108.next()) {
            _this.e=_it_108[0];
            
            _this.e.position.addX(_this.e.position.sub(_this.position).normalizeX());
            _this.g.refresh(_this.e);
            _this.e.rotation+=1;
            
          }
          if (_this.getkey(32)) {
            _this.print(_this.g.allCount());
          }
          _this.update();
          
        }
      },
      fiber$main :function _trc_GridTest_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var _it_108;
        
        _this.size=50;
        _this.x=_this.y=100;
        _this.zOrder=- 10;
        _this.p=Tonyu.globals.$pat_neko;
        _this.g=new Tonyu.classes.user.ObjectGrid({size: 50});
        _this.s=new Tonyu.classes.user.ObjectSet;
        
        _thread.enter(function _trc_GridTest_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.i=0;
            case 1:
              if (!(_this.i<100)) { __pc=4     ; break; }
              _this.a = new Tonyu.classes.kernel.Actor({x: _this.rnd(400),y: _this.rnd(400)});
              
              _this.g.refresh(_this.a);
              _this.s.add(_this.a);
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
            case 3     :
              _this.i++;
              __pc=1;break;
            case 4     :
              
            case 5:
              _this.x=Tonyu.globals.$mouseX;
              _this.y=Tonyu.globals.$mouseY;
              _it_108=Tonyu.iterator(_this.g.around(_this.x,_this.y),1);
              while(_it_108.next()) {
                _this.e=_it_108[0];
                
                _this.e.position.addX(_this.e.position.sub(_this.position).normalizeX());
                _this.g.refresh(_this.e);
                _this.e.rotation+=1;
                
              }
              if (_this.getkey(32)) {
                _this.print(_this.g.allCount());
              }
              _this.fiber$update(_thread);
              __pc=6;return;
            case 6:
              
              __pc=5;break;
            case 7     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{"a":{},"e":{},"g":{},"s":{},"i":{}}}
});
Tonyu.klass.define({
  fullName: 'user.House',
  shortName: 'House',
  namespace: 'user',
  superclass: Tonyu.classes.user.Speedable,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_House_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_House_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.Main',
  shortName: 'Main',
  namespace: 'user',
  superclass: Tonyu.classes.user.Speedable,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Main_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$map=new Tonyu.classes.kernel.Map;
        Tonyu.globals.$cars=new Tonyu.classes.user.ObjectGrid;
        Tonyu.globals.$map.load("map2.json");
        _this.i = 0;
        for (; _this.i<Tonyu.globals.$map.row ; _this.i++) {
          {
            _this.j = 0;
            for (; _this.j<Tonyu.globals.$map.col ; _this.j++) {
              {
                if (Tonyu.globals.$map.get(_this.j,_this.i)==Tonyu.globals.$pat_mapchip+14) {
                  new Tonyu.classes.user.Cross({x: _this.j*32+16,y: _this.i*32+16});
                  
                }
              }
            }
          }
        }
        Tonyu.globals.$Screen.resize(900,800);
        Tonyu.globals.$Screen.setPivot(Tonyu.globals.$screenWidth/2,Tonyu.globals.$screenHeight/2);
        _this.sx=580+256;
        _this.sy=380+256;
        Tonyu.globals.$Screen.scrollTo(_this.sx,_this.sy);
        _this.a=new Tonyu.classes.kernel.APad;
        _this.update();
        new Tonyu.classes.user.CarGen;
        while (true) {
          _this.i=0;for (; _this.i<60 ; _this.i++) {
            {
              _this.sx+=_this.a.vx*3;
              _this.sy+=_this.a.vy*3;
              Tonyu.globals.$Screen.scrollTo(_this.sx,_this.sy);
              _this.update();
            }
          }
          
        }
      },
      fiber$main :function _trc_Main_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$map=new Tonyu.classes.kernel.Map;
        Tonyu.globals.$cars=new Tonyu.classes.user.ObjectGrid;
        Tonyu.globals.$map.load("map2.json");
        _this.i = 0;
        for (; _this.i<Tonyu.globals.$map.row ; _this.i++) {
          {
            _this.j = 0;
            for (; _this.j<Tonyu.globals.$map.col ; _this.j++) {
              {
                if (Tonyu.globals.$map.get(_this.j,_this.i)==Tonyu.globals.$pat_mapchip+14) {
                  new Tonyu.classes.user.Cross({x: _this.j*32+16,y: _this.i*32+16});
                  
                }
              }
            }
          }
        }
        Tonyu.globals.$Screen.resize(900,800);
        Tonyu.globals.$Screen.setPivot(Tonyu.globals.$screenWidth/2,Tonyu.globals.$screenHeight/2);
        _this.sx=580+256;
        _this.sy=380+256;
        Tonyu.globals.$Screen.scrollTo(_this.sx,_this.sy);
        _this.a=new Tonyu.classes.kernel.APad;
        
        _thread.enter(function _trc_Main_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$update(_thread);
              __pc=1;return;
            case 1:
              
              new Tonyu.classes.user.CarGen;
            case 2:
              _this.i=0;
            case 3:
              if (!(_this.i<60)) { __pc=6     ; break; }
              _this.sx+=_this.a.vx*3;
              _this.sy+=_this.a.vy*3;
              Tonyu.globals.$Screen.scrollTo(_this.sx,_this.sy);
              _this.fiber$update(_thread);
              __pc=4;return;
            case 4:
              
            case 5     :
              _this.i++;
              __pc=3;break;
            case 6     :
              
              __pc=2;break;
            case 7     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      spawn :function _trc_Main_spawn(params) {
        "use strict";
        var _this=this;
        
        _this.x=params.x;
        _this.y=params.y;
        if (! _this.within(Tonyu.classes.user.Car,64)) {
          new Tonyu.classes.user.Car(params);
          
        }
      },
      fiber$spawn :function _trc_Main_f_spawn(_thread,params) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.x=params.x;
        _this.y=params.y;
        if (! _this.within(Tonyu.classes.user.Car,64)) {
          new Tonyu.classes.user.Car(params);
          
        }
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"spawn":{"nowait":false}},"fields":{"i":{},"j":{},"sx":{},"sy":{},"a":{}}}
});
Tonyu.klass.define({
  fullName: 'user.MapGen',
  shortName: 'MapGen',
  namespace: 'user',
  superclass: Tonyu.classes.user.Speedable,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_MapGen_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$Screen.resize(600,750);
        Tonyu.globals.$Screen.setBGColor("#080");
        Tonyu.globals.$Screen.setPivot(Tonyu.globals.$screenWidth/2,Tonyu.globals.$screenHeight/2-75);
        Tonyu.globals.$cp=new Tonyu.classes.user.CP;
        Tonyu.globals.$map=new Tonyu.classes.kernel.Map;
        Tonyu.globals.$map.load("map.json");
        Tonyu.globals.$map.alpha=0;
        Tonyu.globals.$tmpl=new Tonyu.classes.kernel.Map;
        Tonyu.globals.$tmpl.load("map2.json");
        Tonyu.globals.$tmpl.alpha=0;
        if (Tonyu.globals.$clearCnt==null) {
          Tonyu.globals.$clearCnt=0;
        }
        Tonyu.globals.$dirWarn=new Tonyu.classes.kernel.Label({text: "※どちらに曲がるかは，\n交差点に入る前に決めてください",x: 200,y: Tonyu.globals.$screenHeight-200,size: 24,alpha: 0});
        _this.parallel("dirwarn",Tonyu.globals.$dirWarn);
        Tonyu.globals.$url="https://www.tonyu.jp/project/viewProject.cgi?mainkey=807&";
        Tonyu.globals.$speed=2;
        Tonyu.globals.$flags=5;
        Tonyu.globals.$gmap=new Tonyu.classes.kernel.Map({row: Tonyu.globals.$map.row*3,col: Tonyu.globals.$map.col*3});
        _this.i=0;for (; _this.i<Tonyu.globals.$map.row ; _this.i++) {
          {
            _this.j=0;for (; _this.j<Tonyu.globals.$map.col ; _this.j++) {
              {
                _this.pp=Tonyu.globals.$map.get(_this.j,_this.i);
                if (Tonyu.globals.$map.getOn(_this.j,_this.i)===Tonyu.globals.$pat_mapchip+4) {
                  Tonyu.globals.$mycar={x: _this.j*32*3+16,y: _this.i*32*3+48,mycar: true};
                  _this.parallel("scanim",Tonyu.globals.$mycar);
                  
                }
                if (Tonyu.globals.$map.getOn(_this.j,_this.i)===Tonyu.globals.$pat_mapchip+5) {
                  Tonyu.globals.$ecar={x: _this.j*32*3+16,y: _this.i*32*3+48,ecar: ! true};
                  
                }
                _this.yy=0;for (; _this.yy<3 ; _this.yy++) {
                  {
                    _this.xx=0;for (; _this.xx<3 ; _this.xx++) {
                      {
                        Tonyu.globals.$gmap.set(_this.j*3+_this.xx,_this.i*3+_this.yy,_this.pp);
                      }
                    }
                  }
                }
              }
            }
            _this.update();
          }
        }
        _this.sig2Tmpl = [];
        
        _this.i=0;for (; _this.i<Tonyu.globals.$tmpl.row ; _this.i++) {
          {
            _this.j=0;for (; _this.j<Tonyu.globals.$tmpl.col ; _this.j++) {
              {
                _this.pp=Tonyu.globals.$tmpl.get(_this.j,_this.i);
                if (_this.pp==Tonyu.globals.$pat_mapchip+14) {
                  _this.sig2Tmpl[_this.dirSig(Tonyu.globals.$tmpl,_this.j,_this.i)]={x: _this.j,y: _this.i};
                  
                }
              }
            }
            _this.update();
          }
        }
        delete _this.sig2Tmpl[3];
        delete _this.sig2Tmpl[6];
        delete _this.sig2Tmpl[12];
        delete _this.sig2Tmpl[9];
        _this.pass=1;for (; _this.pass<=2 ; _this.pass++) {
          {
            _this.yy=1;for (; _this.yy<Tonyu.globals.$gmap.row ; _this.yy+=3) {
              {
                _this.xx=1;for (; _this.xx<Tonyu.globals.$gmap.col ; _this.xx+=3) {
                  {
                    if (_this.isRoad(Tonyu.globals.$gmap.get(_this.xx,_this.yy))) {
                      _this.sig = _this.dirSig(Tonyu.globals.$gmap,_this.xx,_this.yy);
                      
                      if (_this.pass==1) {
                        switch (_this.sig) {
                        case 5:
                          Tonyu.globals.$gmap.set(_this.xx,_this.yy-1,Tonyu.globals.$pat_mapchip+0);
                          Tonyu.globals.$gmap.set(_this.xx,_this.yy,Tonyu.globals.$pat_mapchip+0);
                          Tonyu.globals.$gmap.set(_this.xx,_this.yy+1,Tonyu.globals.$pat_mapchip+0);
                          break;
                          
                        case 10:
                          Tonyu.globals.$gmap.set(_this.xx-1,_this.yy,Tonyu.globals.$pat_mapchip+3);
                          Tonyu.globals.$gmap.set(_this.xx,_this.yy,Tonyu.globals.$pat_mapchip+3);
                          Tonyu.globals.$gmap.set(_this.xx+1,_this.yy,Tonyu.globals.$pat_mapchip+3);
                          break;
                          
                        default:
                          Tonyu.globals.$gmap.set(_this.xx,_this.yy,Tonyu.globals.$pat_mapchip+14);
                        }
                        
                      } else {
                        if (_this.sig2Tmpl[_this.sig]) {
                          _this.copy(Tonyu.globals.$tmpl,_this.sig2Tmpl[_this.sig],Tonyu.globals.$gmap,{x: _this.xx,y: _this.yy});
                          
                        }
                        
                      }
                      
                    }
                  }
                }
                _this.update();
              }
            }
          }
        }
        Tonyu.globals.$tmpl.die();
        Tonyu.globals.$map.die();
        Tonyu.globals.$map=Tonyu.globals.$gmap;
        Tonyu.globals.$crosses=new Tonyu.classes.user.ObjectGrid({size: 200});
        _this.i = 0;
        for (; _this.i<Tonyu.globals.$map.row ; _this.i++) {
          {
            _this.j = 0;
            for (; _this.j<Tonyu.globals.$map.col ; _this.j++) {
              {
                if (Tonyu.globals.$map.get(_this.j,_this.i)==Tonyu.globals.$pat_mapchip+14) {
                  Tonyu.globals.$crosses.refresh(new Tonyu.classes.user.Cross({x: _this.j*32+16,y: _this.i*32+16}));
                  
                }
              }
            }
          }
        }
        Tonyu.globals.$cars=new Tonyu.classes.user.ObjectGrid;
        _this.update();
        Tonyu.globals.$mycar=new Tonyu.classes.user.Car(Tonyu.globals.$mycar);
        Tonyu.globals.$ecar=new Tonyu.classes.user.Car(Tonyu.globals.$ecar);
        Tonyu.globals.$flagsLeft=Tonyu.globals.$flags;
        Tonyu.globals.$raderFree=300;
        new Tonyu.classes.user.CarGen;
        Tonyu.globals.$rader=new Tonyu.classes.user.Rader;
        while (! Tonyu.globals.$mycar) {
          _this.update();
        }
        Tonyu.globals.$sound.playBGM(Tonyu.globals.$se_ral,true);
        _this.p=1;
        _this.alpha=255;
        _this.zOrder=- 100;
        _this.sp=Tonyu.globals.$mycar.position.clone();
        Tonyu.globals.$mcts=[new Tonyu.classes.kernel.Vec3({x: _this.rnd(Tonyu.globals.$map.col*32),y: _this.rnd(Tonyu.globals.$map.row*32)}),new Tonyu.classes.kernel.Vec3({x: _this.rnd(Tonyu.globals.$map.col*32),y: _this.rnd(Tonyu.globals.$map.row*32)}),new Tonyu.classes.kernel.Vec3({x: _this.rnd(Tonyu.globals.$map.col*32),y: _this.rnd(Tonyu.globals.$map.row*32)})];
        Tonyu.globals.$state="play";
        Tonyu.globals.$msv=Tonyu.globals.$map.draw;
        while (Tonyu.globals.$state=="play") {
          _this.spt=Tonyu.globals.$mycar.position.add(Tonyu.globals.$mycar.dir.mul(200));
          if (_this.spt.sub(_this.sp).length>5) {
            _this.sp.addX(_this.spt.sub(_this.sp).normalizeX(5));
          } else {
            _this.sp.set(_this.spt);
          }
          Tonyu.globals.$Screen.scrollTo(_this.sp.x,_this.sp.y);
          if (Tonyu.globals.$doprofile&&_this.getkey("q")==1) {
            Tonyu.globals.$debugger.Profiler.profile();
            _this.updateEx(3);
            console.log(Tonyu.globals.$debugger.Profiler.report().filter((function anonymous_4672(e) {
              
              return e.name.match(/user/);
            })));
            Tonyu.globals.$Boot.stop();
            Tonyu.globals.$nodraw=! Tonyu.globals.$nodraw;
            
          }
          if (_this.rnd(1000)==0) {
            Tonyu.globals.$mcts[_this.rnd(3)]=new Tonyu.classes.kernel.Vec3({x: _this.rnd(Tonyu.globals.$map.col*32),y: _this.rnd(Tonyu.globals.$map.row*32)});
          }
          Tonyu.globals.$sound.setBGMTempo(Tonyu.globals.$speed);
          _this.update();
          
        }
        if (Tonyu.globals.$state=="clear") {
          Tonyu.globals.$sound.playBGM(Tonyu.globals.$se_kuria);
          new Tonyu.classes.kernel.Label({size: 30,x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight/2,text: "CLEAR"});
          Tonyu.globals.$mesg="【ペーパーカー】すべての家に新聞を配達した！";
          
        } else {
          new Tonyu.classes.kernel.Actor({x: Tonyu.globals.$screenWidth/2,y: 200,p: Tonyu.globals.$pat_fire,layer: Tonyu.globals.$frontLayer});
          Tonyu.globals.$mesg="【ペーパーカー】"+(Tonyu.globals.$flags-Tonyu.globals.$flagsLeft)+"部の新聞を配ったがくびになった．";
          
        }
        new Tonyu.classes.kernel.Button({top: 500,text: "Replay",onClick: (function anonymous_5438() {
          
          _this.loadPage(Tonyu.classes.user.MapGen);
        })});
        new Tonyu.classes.kernel.Button({text: "Tweet",top: 550,onClick: Tonyu.bindFunc(_this,_this.tweet)});
      },
      fiber$main :function _trc_MapGen_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$Screen.resize(600,750);
        Tonyu.globals.$Screen.setBGColor("#080");
        Tonyu.globals.$Screen.setPivot(Tonyu.globals.$screenWidth/2,Tonyu.globals.$screenHeight/2-75);
        Tonyu.globals.$cp=new Tonyu.classes.user.CP;
        Tonyu.globals.$map=new Tonyu.classes.kernel.Map;
        Tonyu.globals.$map.load("map.json");
        Tonyu.globals.$map.alpha=0;
        Tonyu.globals.$tmpl=new Tonyu.classes.kernel.Map;
        Tonyu.globals.$tmpl.load("map2.json");
        Tonyu.globals.$tmpl.alpha=0;
        if (Tonyu.globals.$clearCnt==null) {
          Tonyu.globals.$clearCnt=0;
        }
        Tonyu.globals.$dirWarn=new Tonyu.classes.kernel.Label({text: "※どちらに曲がるかは，\n交差点に入る前に決めてください",x: 200,y: Tonyu.globals.$screenHeight-200,size: 24,alpha: 0});
        _this.parallel("dirwarn",Tonyu.globals.$dirWarn);
        Tonyu.globals.$url="https://www.tonyu.jp/project/viewProject.cgi?mainkey=807&";
        Tonyu.globals.$speed=2;
        Tonyu.globals.$flags=5;
        Tonyu.globals.$gmap=new Tonyu.classes.kernel.Map({row: Tonyu.globals.$map.row*3,col: Tonyu.globals.$map.col*3});
        
        _thread.enter(function _trc_MapGen_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.i=0;
            case 1:
              if (!(_this.i<Tonyu.globals.$map.row)) { __pc=4     ; break; }
              _this.j=0;for (; _this.j<Tonyu.globals.$map.col ; _this.j++) {
                {
                  _this.pp=Tonyu.globals.$map.get(_this.j,_this.i);
                  if (Tonyu.globals.$map.getOn(_this.j,_this.i)===Tonyu.globals.$pat_mapchip+4) {
                    Tonyu.globals.$mycar={x: _this.j*32*3+16,y: _this.i*32*3+48,mycar: true};
                    _this.parallel("scanim",Tonyu.globals.$mycar);
                    
                  }
                  if (Tonyu.globals.$map.getOn(_this.j,_this.i)===Tonyu.globals.$pat_mapchip+5) {
                    Tonyu.globals.$ecar={x: _this.j*32*3+16,y: _this.i*32*3+48,ecar: ! true};
                    
                  }
                  _this.yy=0;for (; _this.yy<3 ; _this.yy++) {
                    {
                      _this.xx=0;for (; _this.xx<3 ; _this.xx++) {
                        {
                          Tonyu.globals.$gmap.set(_this.j*3+_this.xx,_this.i*3+_this.yy,_this.pp);
                        }
                      }
                    }
                  }
                }
              }
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
            case 3     :
              _this.i++;
              __pc=1;break;
            case 4     :
              
              _this.sig2Tmpl = [];
              
              _this.i=0;
            case 5:
              if (!(_this.i<Tonyu.globals.$tmpl.row)) { __pc=8     ; break; }
              _this.j=0;for (; _this.j<Tonyu.globals.$tmpl.col ; _this.j++) {
                {
                  _this.pp=Tonyu.globals.$tmpl.get(_this.j,_this.i);
                  if (_this.pp==Tonyu.globals.$pat_mapchip+14) {
                    _this.sig2Tmpl[_this.dirSig(Tonyu.globals.$tmpl,_this.j,_this.i)]={x: _this.j,y: _this.i};
                    
                  }
                }
              }
              _this.fiber$update(_thread);
              __pc=6;return;
            case 6:
              
            case 7     :
              _this.i++;
              __pc=5;break;
            case 8     :
              
              delete _this.sig2Tmpl[3];
              delete _this.sig2Tmpl[6];
              delete _this.sig2Tmpl[12];
              delete _this.sig2Tmpl[9];
              _this.pass=1;
            case 9:
              if (!(_this.pass<=2)) { __pc=28    ; break; }
              _this.yy=1;
            case 10:
              if (!(_this.yy<Tonyu.globals.$gmap.row)) { __pc=26    ; break; }
              _this.xx=1;
            case 11:
              if (!(_this.xx<Tonyu.globals.$gmap.col)) { __pc=23    ; break; }
              if (!(_this.isRoad(Tonyu.globals.$gmap.get(_this.xx,_this.yy)))) { __pc=21    ; break; }
              _this.fiber$dirSig(_thread, Tonyu.globals.$gmap, _this.xx, _this.yy);
              __pc=12;return;
            case 12:
              _this.sig=_thread.retVal;
              
              if (!(_this.pass==1)) { __pc=17    ; break; }
              switch (_this.sig) {
              case 5:
                __pc=13    ;break;
              case 10:
                __pc=14    ;break;
              default:
                __pc=15    ;break;
                
              }
              break;
            case 13    :
              Tonyu.globals.$gmap.set(_this.xx,_this.yy-1,Tonyu.globals.$pat_mapchip+0);
              Tonyu.globals.$gmap.set(_this.xx,_this.yy,Tonyu.globals.$pat_mapchip+0);
              Tonyu.globals.$gmap.set(_this.xx,_this.yy+1,Tonyu.globals.$pat_mapchip+0);
              __pc=16    ; break;
              
            case 14    :
              Tonyu.globals.$gmap.set(_this.xx-1,_this.yy,Tonyu.globals.$pat_mapchip+3);
              Tonyu.globals.$gmap.set(_this.xx,_this.yy,Tonyu.globals.$pat_mapchip+3);
              Tonyu.globals.$gmap.set(_this.xx+1,_this.yy,Tonyu.globals.$pat_mapchip+3);
              __pc=16    ; break;
              
            case 15    :
              Tonyu.globals.$gmap.set(_this.xx,_this.yy,Tonyu.globals.$pat_mapchip+14);
              case 16    :
              
              __pc=20    ;break;
            case 17    :
              if (!(_this.sig2Tmpl[_this.sig])) { __pc=19    ; break; }
              _this.fiber$copy(_thread, Tonyu.globals.$tmpl, _this.sig2Tmpl[_this.sig], Tonyu.globals.$gmap, {x: _this.xx,y: _this.yy});
              __pc=18;return;
            case 18:
              
            case 19    :
              
            case 20    :
              
            case 21    :
              
            case 22    :
              _this.xx+=3;
              __pc=11;break;
            case 23    :
              
              _this.fiber$update(_thread);
              __pc=24;return;
            case 24:
              
            case 25    :
              _this.yy+=3;
              __pc=10;break;
            case 26    :
              
            case 27    :
              _this.pass++;
              __pc=9;break;
            case 28    :
              
              Tonyu.globals.$tmpl.die();
              Tonyu.globals.$map.die();
              Tonyu.globals.$map=Tonyu.globals.$gmap;
              Tonyu.globals.$crosses=new Tonyu.classes.user.ObjectGrid({size: 200});
              _this.i = 0;
              for (; _this.i<Tonyu.globals.$map.row ; _this.i++) {
                {
                  _this.j = 0;
                  for (; _this.j<Tonyu.globals.$map.col ; _this.j++) {
                    {
                      if (Tonyu.globals.$map.get(_this.j,_this.i)==Tonyu.globals.$pat_mapchip+14) {
                        Tonyu.globals.$crosses.refresh(new Tonyu.classes.user.Cross({x: _this.j*32+16,y: _this.i*32+16}));
                        
                      }
                    }
                  }
                }
              }
              Tonyu.globals.$cars=new Tonyu.classes.user.ObjectGrid;
              _this.fiber$update(_thread);
              __pc=29;return;
            case 29:
              
              Tonyu.globals.$mycar=new Tonyu.classes.user.Car(Tonyu.globals.$mycar);
              Tonyu.globals.$ecar=new Tonyu.classes.user.Car(Tonyu.globals.$ecar);
              Tonyu.globals.$flagsLeft=Tonyu.globals.$flags;
              Tonyu.globals.$raderFree=300;
              new Tonyu.classes.user.CarGen;
              Tonyu.globals.$rader=new Tonyu.classes.user.Rader;
            case 30:
              if (!(! Tonyu.globals.$mycar)) { __pc=32    ; break; }
              _this.fiber$update(_thread);
              __pc=31;return;
            case 31:
              
              __pc=30;break;
            case 32    :
              
              Tonyu.globals.$sound.playBGM(Tonyu.globals.$se_ral,true);
              _this.p=1;
              _this.alpha=255;
              _this.zOrder=- 100;
              _this.sp=Tonyu.globals.$mycar.position.clone();
              Tonyu.globals.$mcts=[new Tonyu.classes.kernel.Vec3({x: _this.rnd(Tonyu.globals.$map.col*32),y: _this.rnd(Tonyu.globals.$map.row*32)}),new Tonyu.classes.kernel.Vec3({x: _this.rnd(Tonyu.globals.$map.col*32),y: _this.rnd(Tonyu.globals.$map.row*32)}),new Tonyu.classes.kernel.Vec3({x: _this.rnd(Tonyu.globals.$map.col*32),y: _this.rnd(Tonyu.globals.$map.row*32)})];
              Tonyu.globals.$state="play";
              Tonyu.globals.$msv=Tonyu.globals.$map.draw;
            case 33:
              if (!(Tonyu.globals.$state=="play")) { __pc=37    ; break; }
              _this.spt=Tonyu.globals.$mycar.position.add(Tonyu.globals.$mycar.dir.mul(200));
              if (_this.spt.sub(_this.sp).length>5) {
                _this.sp.addX(_this.spt.sub(_this.sp).normalizeX(5));
              } else {
                _this.sp.set(_this.spt);
              }
              Tonyu.globals.$Screen.scrollTo(_this.sp.x,_this.sp.y);
              if (!(Tonyu.globals.$doprofile&&_this.getkey("q")==1)) { __pc=35    ; break; }
              Tonyu.globals.$debugger.Profiler.profile();
              _this.fiber$updateEx(_thread, 3);
              __pc=34;return;
            case 34:
              
              console.log(Tonyu.globals.$debugger.Profiler.report().filter((function anonymous_4672(e) {
                
                return e.name.match(/user/);
              })));
              Tonyu.globals.$Boot.stop();
              Tonyu.globals.$nodraw=! Tonyu.globals.$nodraw;
            case 35    :
              
              if (_this.rnd(1000)==0) {
                Tonyu.globals.$mcts[_this.rnd(3)]=new Tonyu.classes.kernel.Vec3({x: _this.rnd(Tonyu.globals.$map.col*32),y: _this.rnd(Tonyu.globals.$map.row*32)});
              }
              Tonyu.globals.$sound.setBGMTempo(Tonyu.globals.$speed);
              _this.fiber$update(_thread);
              __pc=36;return;
            case 36:
              
              __pc=33;break;
            case 37    :
              
              if (Tonyu.globals.$state=="clear") {
                Tonyu.globals.$sound.playBGM(Tonyu.globals.$se_kuria);
                new Tonyu.classes.kernel.Label({size: 30,x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight/2,text: "CLEAR"});
                Tonyu.globals.$mesg="【ペーパーカー】すべての家に新聞を配達した！";
                
              } else {
                new Tonyu.classes.kernel.Actor({x: Tonyu.globals.$screenWidth/2,y: 200,p: Tonyu.globals.$pat_fire,layer: Tonyu.globals.$frontLayer});
                Tonyu.globals.$mesg="【ペーパーカー】"+(Tonyu.globals.$flags-Tonyu.globals.$flagsLeft)+"部の新聞を配ったがくびになった．";
                
              }
              new Tonyu.classes.kernel.Button({top: 500,text: "Replay",onClick: (function anonymous_5438() {
                
                _this.loadPage(Tonyu.classes.user.MapGen);
              })});
              new Tonyu.classes.kernel.Button({text: "Tweet",top: 550,onClick: Tonyu.bindFunc(_this,_this.tweet)});
              _thread.exit(_this);return;
            }
          }
        });
      },
      dirwarn :function _trc_MapGen_dirwarn(d) {
        "use strict";
        var _this=this;
        
        while (true) {
          d.alpha--;
          if (d.alpha<200) {
            d.alpha-=10;
          }
          if (d.alpha<0) {
            d.alpha=0;
          }
          _this.updateEx(2);
          
        }
      },
      fiber$dirwarn :function _trc_MapGen_f_dirwarn(_thread,d) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_MapGen_ent_dirwarn(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              d.alpha--;
              if (d.alpha<200) {
                d.alpha-=10;
              }
              if (d.alpha<0) {
                d.alpha=0;
              }
              _this.fiber$updateEx(_thread, 2);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      scanim :function _trc_MapGen_scanim(to) {
        "use strict";
        var _this=this;
        var d;
        var p;
        
        d = new Tonyu.classes.kernel.Vec3(to);
        
        p = d.add(0,- 8*120);
        
        while (p.dist(d)>8) {
          p.addX(d.sub(p).normalizeX(8));
          Tonyu.globals.$Screen.scrollTo(p.x,p.y);
          _this.update();
          
        }
      },
      fiber$scanim :function _trc_MapGen_f_scanim(_thread,to) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var d;
        var p;
        
        d = new Tonyu.classes.kernel.Vec3(to);
        
        p = d.add(0,- 8*120);
        
        
        _thread.enter(function _trc_MapGen_ent_scanim(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(p.dist(d)>8)) { __pc=3     ; break; }
              p.addX(d.sub(p).normalizeX(8));
              Tonyu.globals.$Screen.scrollTo(p.x,p.y);
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      dirSig :function _trc_MapGen_dirSig(map,x,y) {
        "use strict";
        var _this=this;
        var res;
        var bit;
        var d;
        
        res = 0;
        bit = 1;
        
        d = 0;
        for (; d<360 ; d+=90) {
          {
            if (_this.isRoad(map.get(x+_this.sin(d)*2,y-_this.cos(d)*2))) {
              res+=bit;
              
            }
            bit*=2;
          }
        }
        return res;
      },
      fiber$dirSig :function _trc_MapGen_f_dirSig(_thread,map,x,y) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var res;
        var bit;
        var d;
        
        res = 0;
        bit = 1;
        
        d = 0;
        for (; d<360 ; d+=90) {
          {
            if (_this.isRoad(map.get(x+_this.sin(d)*2,y-_this.cos(d)*2))) {
              res+=bit;
              
            }
            bit*=2;
          }
        }
        _thread.retVal=res;return;
        
        
        _thread.retVal=_this;return;
      },
      copy :function _trc_MapGen_copy(src,spos,dst,dpos) {
        "use strict";
        var _this=this;
        var i;
        var j;
        var p;
        
        i = - 8;
        for (; i<=8 ; i++) {
          {
            j = - 8;
            for (; j<=8 ; j++) {
              {
                p = src.get(spos.x+j,spos.y+i);
                
                if (_this.isRoad(p)) {
                  dst.set(dpos.x+j,dpos.y+i,p);
                  
                }
              }
            }
          }
        }
      },
      fiber$copy :function _trc_MapGen_f_copy(_thread,src,spos,dst,dpos) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var i;
        var j;
        var p;
        
        i = - 8;
        for (; i<=8 ; i++) {
          {
            j = - 8;
            for (; j<=8 ; j++) {
              {
                p = src.get(spos.x+j,spos.y+i);
                
                if (_this.isRoad(p)) {
                  dst.set(dpos.x+j,dpos.y+i,p);
                  
                }
              }
            }
          }
        }
        
        _thread.retVal=_this;return;
      },
      isRoad :function _trc_MapGen_isRoad(p) {
        "use strict";
        var _this=this;
        
        return p!==- 1&&p!==Tonyu.globals.$pat_mapchip+11;
      },
      fiber$isRoad :function _trc_MapGen_f_isRoad(_thread,p) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=p!==- 1&&p!==Tonyu.globals.$pat_mapchip+11;return;
        
        
        _thread.retVal=_this;return;
      },
      tweet :function _trc_MapGen_tweet() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$WebPage.openShareTweet(Tonyu.globals.$mesg,Tonyu.globals.$url,"tonyu2,ahoge");
      },
      fiber$tweet :function _trc_MapGen_f_tweet(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$WebPage.openShareTweet(Tonyu.globals.$mesg,Tonyu.globals.$url,"tonyu2,ahoge");
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"dirwarn":{"nowait":false},"scanim":{"nowait":false},"dirSig":{"nowait":false},"copy":{"nowait":false},"isRoad":{"nowait":false},"tweet":{"nowait":false}},"fields":{"sig2Tmpl":{},"sig":{},"i":{},"j":{},"pp":{},"yy":{},"xx":{},"pass":{},"sp":{},"spt":{}}}
});
Tonyu.klass.define({
  fullName: 'user.MapMa',
  shortName: 'MapMa',
  namespace: 'user',
  superclass: Tonyu.classes.user.Speedable,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_MapMa_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$map=new Tonyu.classes.kernel.Map;
        Tonyu.globals.$map.load("map2.json");
        Tonyu.globals.$Screen.scrollTo(0,0,0.2);
        _this.updateEx(60);
        _this.by=8;
        _this.i = Tonyu.globals.$map.row-1-_this.by;
        for (; _this.i>=0 ; _this.i--) {
          {
            _this.j = Tonyu.globals.$map.col-1-_this.by;
            for (; _this.j>=0 ; _this.j--) {
              {
                Tonyu.globals.$map.set(_this.j+_this.by,_this.i+_this.by,Tonyu.globals.$map.get(_this.j,_this.i));
              }
            }
          }
        }
      },
      fiber$main :function _trc_MapMa_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$map=new Tonyu.classes.kernel.Map;
        Tonyu.globals.$map.load("map2.json");
        Tonyu.globals.$Screen.scrollTo(0,0,0.2);
        
        _thread.enter(function _trc_MapMa_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$updateEx(_thread, 60);
              __pc=1;return;
            case 1:
              
              _this.by=8;
              _this.i = Tonyu.globals.$map.row-1-_this.by;
              for (; _this.i>=0 ; _this.i--) {
                {
                  _this.j = Tonyu.globals.$map.col-1-_this.by;
                  for (; _this.j>=0 ; _this.j--) {
                    {
                      Tonyu.globals.$map.set(_this.j+_this.by,_this.i+_this.by,Tonyu.globals.$map.get(_this.j,_this.i));
                    }
                  }
                }
              }
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{"i":{},"j":{},"by":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Signal',
  shortName: 'Signal',
  namespace: 'user',
  superclass: Tonyu.classes.user.Speedable,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Signal_main() {
        "use strict";
        var _this=this;
        
        _this.bp=Tonyu.globals.$pat_mapchip+15;
        _this.state=4;
      },
      fiber$main :function _trc_Signal_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.bp=Tonyu.globals.$pat_mapchip+15;
        _this.state=4;
        
        _thread.retVal=_this;return;
      },
      draw :function _trc_Signal_draw(ctx) {
        "use strict";
        var _this=this;
        
        _this.p=_this.bp+_this.state;
        __superClass.prototype.draw.apply( _this, [ctx]);
      },
      goable :function _trc_Signal_goable(dir) {
        "use strict";
        var _this=this;
        
        switch (dir) {
        case "str":
          
        case "left":
          return _this.state===0;
        case "right":
          return _this.state<3;
        }
      },
      fiber$goable :function _trc_Signal_f_goable(_thread,dir) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        switch (dir) {
        case "str":
          
        case "left":
          _thread.retVal=_this.state===0;return;
          
        case "right":
          _thread.retVal=_this.state<3;return;
          
        }
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"draw":{"nowait":true},"goable":{"nowait":false}},"fields":{"bp":{},"state":{}}}
});

//# sourceMappingURL=concat.js.map